import { useContext } from 'react';
import '../Provider/ThemeContext.js';
import 'classnames';
import 'emotion';
import '@emotion/core';
import 'emotion-theming';
import '@emotion/styled';
import '../utils/useTheme.js';
import { _ as _objectSpread2 } from '../chunk-0c448560.js';
import 'lodash/kebabCase';
import 'tinycolor2';
import '../utils/isFunction.js';
import '../utils/get.js';
import '../utils/theme.js';
import '../utils/omit.js';
import '../utils/pick.js';
import '../utils/cssProps.js';
import '../utils/useLocalStorage.js';
import '../Provider/ColorModeContext.js';
import '../utils/useColorMode.js';
import '../utils/useStyle.js';
import '../utils/omitBy.js';
import '../utils/useDefaultProps.js';
import '../utils/useDebounce.js';
import 'lodash/uniq';
import { useClassName } from '../utils/useClassName.js';
import '../utils/useBreakpoint.js';
import '../utils/uniqueId.js';
import '../utils/times.js';
import '../utils/parseIcons.js';
import '../utils/colors.js';
import '../utils/palette.js';
import '../utils/mergeRefs.js';
import 'deepmerge';
import 'lodash/set';
import '../utils/applyTheme.js';
import '../utils/bindFns.js';
import { createComponent } from '../utils/createComponent.js';
import { createElement } from '../utils/createElement.js';
import { createHook } from '../utils/createHook.js';
import '../utils/forwardRefWithUse.js';
import '../utils/fieldAdaptors.js';
import '@emotion/is-prop-valid';
import '../utils/htmlProps.js';
import '../utils/OutsideClickHandler.js';
import { Box } from 'reakit';
import '../Box/styles-579aeb3a.js';
import { Box as Box$1 } from '../Box/Box.js';
import { a as Column$1 } from './styles-a64137b7.js';
import { ColumnsContext } from './ColumnsContext.js';

var useProps = createHook(function (props, _ref) {
  var themeKey = _ref.themeKey,
      themeKeyOverride = _ref.themeKeyOverride;
  var boxProps = Box$1.useProps(props);
  var columnsContext = useContext(ColumnsContext);
  var className = useClassName({
    style: Column$1,
    styleProps: _objectSpread2(_objectSpread2({}, props), columnsContext),
    themeKey: themeKey,
    themeKeyOverride: themeKeyOverride,
    prevClassName: boxProps.className
  });
  return _objectSpread2(_objectSpread2({}, boxProps), {}, {
    className: className
  });
}, {
  defaultProps: {
    spread: undefined,
    spreadMobile: undefined,
    spreadTablet: undefined,
    spreadDesktop: undefined,
    spreadWidescreen: undefined,
    spreadFullHD: undefined,
    spreadOffset: undefined,
    spreadMobileOffset: undefined,
    spreadTabletOffset: undefined,
    spreadDesktopOffset: undefined,
    spreadWidescreenOffset: undefined,
    spreadFullHDOffset: undefined
  },
  themeKey: 'Columns.Column'
});
var Column = createComponent(function (props) {
  var columnProps = useProps(props);
  return createElement({
    children: props.children,
    component: Box,
    use: props.use,
    htmlProps: columnProps
  });
}, {
  attach: {
    useProps: useProps,
    displayName: 'Columns.Column'
  },
  themeKey: 'Columns.Column'
});

export { Column };
