import 'react';
import '../Provider/ThemeContext.js';
import 'classnames';
import 'emotion';
import '@emotion/core';
import 'emotion-theming';
import '@emotion/styled';
import '../utils/useTheme.js';
import '../chunk-0c448560.js';
import 'lodash/kebabCase';
import 'tinycolor2';
import '../utils/isFunction.js';
import '../utils/get.js';
import '../utils/theme.js';
import '../utils/omit.js';
import '../utils/pick.js';
import '../utils/cssProps.js';
import '../utils/useLocalStorage.js';
import '../Provider/ColorModeContext.js';
import '../utils/useColorMode.js';
import '../utils/useStyle.js';
import '../utils/omitBy.js';
import '../utils/useDefaultProps.js';
import '../utils/useDebounce.js';
import 'lodash/uniq';
import '../utils/useClassName.js';
import '../utils/useBreakpoint.js';
import '../utils/uniqueId.js';
import '../utils/times.js';
import '../utils/parseIcons.js';
import '../utils/colors.js';
import '../utils/palette.js';
import '../utils/mergeRefs.js';
import 'deepmerge';
import 'lodash/set';
import '../utils/applyTheme.js';
import '../utils/bindFns.js';
import '../utils/createComponent.js';
import '../utils/createElement.js';
import '../utils/createHook.js';
import '../utils/forwardRefWithUse.js';
import '../utils/fieldAdaptors.js';
import '@emotion/is-prop-valid';
import '../utils/htmlProps.js';
import '../utils/OutsideClickHandler.js';
import '../theme/palette.js';
import '../ActionButtons/styles-16534e2b.js';
import 'reakit';
import '../Button/styles-d451730b.js';
import 'conditional-wrap';
import '../Box/styles-579aeb3a.js';
import '../Box/Box.js';
import '../Flex/styles-e3ee5bb0.js';
import '../Flex/Flex.js';
import '../Icon/styles-f429b8b4.js';
import '../Icon/Icon.js';
import '../Text/styles-58fa853a.js';
import '../Text/Text.js';
import '../Spinner/styles-25413c76.js';
import '../Spinner/Spinner.js';
import '../Button/Button.js';
import 'reakit/VisuallyHidden';
import '../Button/ButtonClose.js';
import '../Button/index.js';
import '../Set/styles-04fbf221.js';
import '../Set/Set.js';
import '../ActionButtons/ActionButtons.js';
import '../Modal/styles-12a7c3c1.js';
export { s as popoverStyles } from './styles-c320f701.js';
import { usePopoverState, PopoverState } from './PopoverState.js';
export { PopoverState, PopoverStateContext, usePopoverState } from './PopoverState.js';
import { Popover as Popover$1, PopoverArrow, PopoverContent, PopoverFooter, PopoverHeader, PopoverTitle } from './Popover.js';
export { PopoverArrow, PopoverContent, PopoverContext, PopoverFooter, PopoverHeader, PopoverTitle } from './Popover.js';
import { PopoverBackdrop } from './PopoverBackdrop.js';
export { PopoverBackdrop } from './PopoverBackdrop.js';
import { PopoverDisclosure } from './PopoverDisclosure.js';
export { PopoverDisclosure } from './PopoverDisclosure.js';

var Popover = Object.assign(Popover$1, {
  Arrow: PopoverArrow,
  Backdrop: PopoverBackdrop,
  Content: PopoverContent,
  Disclosure: PopoverDisclosure,
  Footer: PopoverFooter,
  Header: PopoverHeader,
  Title: PopoverTitle,
  useState: usePopoverState,
  State: PopoverState
});

export { Popover };
