import { createContext, useContext, useMemo, createElement as createElement$1 } from 'react';
import '../Provider/ThemeContext.js';
import 'classnames';
import 'emotion';
import '@emotion/core';
import 'emotion-theming';
import '@emotion/styled';
import '../utils/useTheme.js';
import { d as _objectWithoutPropertiesLoose, _ as _objectSpread2 } from '../chunk-0c448560.js';
import 'lodash/kebabCase';
import 'tinycolor2';
import '../utils/isFunction.js';
import '../utils/get.js';
import '../utils/theme.js';
import '../utils/omit.js';
import '../utils/pick.js';
import '../utils/cssProps.js';
import '../utils/useLocalStorage.js';
import '../Provider/ColorModeContext.js';
import '../utils/useColorMode.js';
import '../utils/useStyle.js';
import '../utils/omitBy.js';
import '../utils/useDefaultProps.js';
import '../utils/useDebounce.js';
import 'lodash/uniq';
import { useClassName } from '../utils/useClassName.js';
import '../utils/useBreakpoint.js';
import { useUniqueId } from '../utils/uniqueId.js';
import '../utils/times.js';
import '../utils/parseIcons.js';
import '../utils/colors.js';
import '../utils/palette.js';
import '../utils/mergeRefs.js';
import 'deepmerge';
import 'lodash/set';
import '../utils/applyTheme.js';
import '../utils/bindFns.js';
import { createComponent } from '../utils/createComponent.js';
import { createElement } from '../utils/createElement.js';
import { createHook } from '../utils/createHook.js';
import '../utils/forwardRefWithUse.js';
import '../utils/fieldAdaptors.js';
import '@emotion/is-prop-valid';
import '../utils/htmlProps.js';
import '../utils/OutsideClickHandler.js';
import { Box } from 'reakit';
import '../Box/styles-579aeb3a.js';
import { Box as Box$1 } from '../Box/Box.js';
import '../List/styles-1f3418ce.js';
import '../List/List.js';
import '../List/ListItem.js';
import { List } from '../List/index.js';
import '../Navigation/styles-ea82e6f3.js';
import '../Navigation/Navigation.js';
import { a as SideNavLevel$1, b as SideNavLevelTitle } from './styles-29a21baa.js';
import { SideNavContext } from './SideNav.js';

var SideNavLevelContext = createContext({
  level: 0
});
var useProps = createHook(function (props, _ref) {
  var themeKey = _ref.themeKey,
      themeKeyOverride = _ref.themeKeyOverride;

  var children = props.children,
      overrides = props.overrides,
      title = props.title,
      restProps = _objectWithoutPropertiesLoose(props, ["children", "overrides", "title"]);

  var listProps = List.useProps(restProps);

  var _React$useContext = useContext(SideNavContext),
      sideNavOverrides = _React$useContext.overrides;

  var _React$useContext2 = useContext(SideNavLevelContext),
      level = _React$useContext2.level;

  var className = useClassName({
    style: SideNavLevel$1,
    styleProps: _objectSpread2(_objectSpread2({}, props), {}, {
      level: level,
      overrides: _objectSpread2(_objectSpread2({}, sideNavOverrides), overrides)
    }),
    themeKey: themeKey,
    themeKeyOverride: themeKeyOverride,
    prevClassName: listProps.className
  });
  var titleClassName = useClassName({
    style: SideNavLevelTitle,
    styleProps: _objectSpread2(_objectSpread2({}, props), {}, {
      level: level,
      overrides: _objectSpread2(_objectSpread2({}, sideNavOverrides), overrides)
    }),
    themeKey: themeKey,
    themeKeyOverride: themeKeyOverride,
    themeKeySuffix: 'Title'
  });
  var contextValue = useMemo(function () {
    return {
      level: level + 1
    };
  }, [level]);
  var titleId = useUniqueId('sideNavLevelTitle');
  return _objectSpread2(_objectSpread2({}, listProps), {}, {
    'aria-labelledby': title ? titleId : undefined,
    className: className,
    children: /*#__PURE__*/createElement$1(SideNavLevelContext.Provider, {
      value: contextValue
    }, title && /*#__PURE__*/createElement$1(Box$1, {
      id: titleId,
      className: titleClassName
    }, title), children)
  });
}, {
  themeKey: 'SideNav.Level'
});
var SideNavLevel = createComponent(function (props) {
  var textProps = useProps(props);
  return createElement({
    children: props.children,
    component: Box,
    use: props.use,
    htmlProps: textProps
  });
}, {
  attach: {
    useProps: useProps,
    displayName: 'SideNav.Level'
  },
  defaultProps: {
    use: 'ul'
  },
  themeKey: 'SideNav.Level'
});

export { SideNavLevel, SideNavLevelContext };
