import 'react';
import '../Provider/ThemeContext.js';
import 'classnames';
import 'emotion';
import '@emotion/core';
import 'emotion-theming';
import '@emotion/styled';
import '../utils/useTheme.js';
import '../chunk-0c448560.js';
import 'lodash/kebabCase';
import 'tinycolor2';
import '../utils/isFunction.js';
import '../utils/get.js';
import '../utils/theme.js';
import '../utils/omit.js';
import '../utils/pick.js';
import '../utils/cssProps.js';
import '../utils/useLocalStorage.js';
import '../Provider/ColorModeContext.js';
import '../utils/useColorMode.js';
import '../utils/useStyle.js';
import '../utils/omitBy.js';
import '../utils/useDefaultProps.js';
import '../utils/useDebounce.js';
import 'lodash/uniq';
import '../utils/useClassName.js';
import '../utils/useBreakpoint.js';
import '../utils/uniqueId.js';
import '../utils/times.js';
import '../utils/parseIcons.js';
import '../utils/colors.js';
import '../utils/palette.js';
import '../utils/mergeRefs.js';
import 'deepmerge';
import 'lodash/set';
import '../utils/applyTheme.js';
import '../utils/bindFns.js';
import '../utils/createComponent.js';
import '../utils/createElement.js';
import '../utils/createHook.js';
import '../utils/forwardRefWithUse.js';
import { formikField, reduxFormField } from '../utils/fieldAdaptors.js';
import '@emotion/is-prop-valid';
import '../utils/htmlProps.js';
import '../utils/OutsideClickHandler.js';
import '../utils/getHiddenInputStyles.js';
import '../theme/palette.js';
import 'reakit';
import '../Button/styles-d451730b.js';
import 'conditional-wrap';
import '../Box/styles-579aeb3a.js';
import '../Box/Box.js';
import '../Flex/styles-e3ee5bb0.js';
import '../Flex/Flex.js';
import '../Icon/styles-f429b8b4.js';
import '../Icon/Icon.js';
import '../Text/styles-58fa853a.js';
import '../Text/Text.js';
import '../Spinner/styles-25413c76.js';
import '../Spinner/Spinner.js';
import '../Button/Button.js';
import 'reakit/VisuallyHidden';
import '../Button/ButtonClose.js';
import '../Button/index.js';
import '../Set/styles-04fbf221.js';
import '../Set/Set.js';
import '../FieldWrapper/styles-084615ad.js';
import '../Card/styles-1666ffe3.js';
import '../Card/Card.js';
import '../Card/index.js';
import '../Disclosure/styles-33b2b9d5.js';
import '../Disclosure/DisclosureState.js';
import '../Disclosure/Disclosure.js';
import '../Disclosure/DisclosureContent.js';
import '../Disclosure/index.js';
import '../Label/styles-68063bea.js';
import '../Label/Label.js';
import '../FieldWrapper/FieldWrapper.js';
export { s as switchStyles } from './styles-3b7154f5.js';
import { Switch as Switch$1, SwitchField as SwitchField$1 } from './Switch.js';
import { SwitchGroup as SwitchGroup$1, SwitchGroupField as SwitchGroupField$1 } from './SwitchGroup.js';

var Switch = Object.assign(Switch$1, {
  Formik: formikField(Switch$1),
  ReduxForm: reduxFormField(Switch$1)
});
var SwitchField = Object.assign(SwitchField$1, {
  Formik: formikField(SwitchField$1, {
    isCheckbox: true,
    hasFieldWrapper: true
  }),
  ReduxForm: reduxFormField(SwitchField$1, {
    isCheckbox: true,
    hasFieldWrapper: true
  })
});
var SwitchGroup = Object.assign(SwitchGroup$1, {
  Formik: formikField(SwitchGroup$1, {
    isCheckboxGroup: true
  }),
  ReduxForm: reduxFormField(SwitchGroup$1, {
    isCheckboxGroup: true
  })
});
var SwitchGroupField = Object.assign(SwitchGroupField$1, {
  Formik: formikField(SwitchGroupField$1, {
    isCheckboxGroup: true,
    hasFieldWrapper: true
  }),
  ReduxForm: reduxFormField(SwitchGroupField$1, {
    isCheckboxGroup: true,
    hasFieldWrapper: true
  })
});

export { Switch, SwitchField, SwitchGroup, SwitchGroupField };
