import 'react';
import '../Provider/ThemeContext.js';
import 'classnames';
import { css } from 'emotion';
import { css as css$1 } from '@emotion/core';
import 'emotion-theming';
import '@emotion/styled';
import '../utils/useTheme.js';
import { a as _taggedTemplateLiteralLoose } from '../chunk-0c448560.js';
import 'lodash/kebabCase';
import 'tinycolor2';
import '../utils/isFunction.js';
import '../utils/get.js';
import { palette, borderRadius, theme, fontWeight } from '../utils/theme.js';
import '../utils/omit.js';
import '../utils/pick.js';
import '../utils/cssProps.js';
import '../utils/useLocalStorage.js';
import '../Provider/ColorModeContext.js';
import '../utils/useColorMode.js';
import '../utils/useStyle.js';
import '../utils/omitBy.js';
import '../utils/useDefaultProps.js';
import '../utils/useDebounce.js';
import 'lodash/uniq';
import '../utils/useClassName.js';
import '../utils/useBreakpoint.js';
import '../utils/uniqueId.js';
import '../utils/times.js';
import '../utils/parseIcons.js';
import '../utils/colors.js';
import '../utils/palette.js';
import '../utils/mergeRefs.js';
import 'deepmerge';
import 'lodash/set';
import '../utils/applyTheme.js';
import '../utils/bindFns.js';
import '../utils/createComponent.js';
import '../utils/createElement.js';
import '../utils/createHook.js';
import '../utils/forwardRefWithUse.js';
import '../utils/fieldAdaptors.js';
import '@emotion/is-prop-valid';
import '../utils/htmlProps.js';
import '../utils/OutsideClickHandler.js';

function _templateObject31() {
  var data = _taggedTemplateLiteralLoose(["\n      justify-content: flex-end;\n\n      & {\n        ", ";\n      }\n    "]);

  _templateObject31 = function _templateObject31() {
    return data;
  };

  return data;
}

function _templateObject30() {
  var data = _taggedTemplateLiteralLoose(["\n      justify-content: center;\n\n      & {\n        ", ";\n      }\n    "]);

  _templateObject30 = function _templateObject30() {
    return data;
  };

  return data;
}

function _templateObject29() {
  var data = _taggedTemplateLiteralLoose(["\n      & {\n        justify-content: start;\n\n        ", ";\n      }\n    "]);

  _templateObject29 = function _templateObject29() {
    return data;
  };

  return data;
}

function _templateObject28() {
  var data = _taggedTemplateLiteralLoose(["\n  &:focus {\n    outline: none;\n  }\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject28 = function _templateObject28() {
    return data;
  };

  return data;
}

function _templateObject27() {
  var data = _taggedTemplateLiteralLoose(["\n            border-bottom: 1px solid ", ";\n          "]);

  _templateObject27 = function _templateObject27() {
    return data;
  };

  return data;
}

function _templateObject26() {
  var data = _taggedTemplateLiteralLoose(["\n            border-right: 1px solid ", ";\n          "]);

  _templateObject26 = function _templateObject26() {
    return data;
  };

  return data;
}

function _templateObject25() {
  var data = _taggedTemplateLiteralLoose(["\n      ", ";\n    "]);

  _templateObject25 = function _templateObject25() {
    return data;
  };

  return data;
}

function _templateObject24() {
  var data = _taggedTemplateLiteralLoose(["\n      flex-direction: column;\n    "]);

  _templateObject24 = function _templateObject24() {
    return data;
  };

  return data;
}

function _templateObject23() {
  var data = _taggedTemplateLiteralLoose(["\n  align-items: center;\n  display: flex;\n  font-weight: ", ";\n\n  ", "\n\n  ", "\n\n\n  ", "\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject23 = function _templateObject23() {
    return data;
  };

  return data;
}

function _templateObject22() {
  var data = _taggedTemplateLiteralLoose(["\n      display: flex;\n    "]);

  _templateObject22 = function _templateObject22() {
    return data;
  };

  return data;
}

function _templateObject21() {
  var data = _taggedTemplateLiteralLoose(["\n      & .fp-TabsTab {\n        flex: 1;\n      }\n    "]);

  _templateObject21 = function _templateObject21() {
    return data;
  };

  return data;
}

function _templateObject20() {
  var data = _taggedTemplateLiteralLoose(["\n  width: 100%;\n\n  ", "\n\n  ", "\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject20 = function _templateObject20() {
    return data;
  };

  return data;
}

function _templateObject19() {
  var data = _taggedTemplateLiteralLoose(["\n        background-color: ", ";\n      "]);

  _templateObject19 = function _templateObject19() {
    return data;
  };

  return data;
}

function _templateObject18() {
  var data = _taggedTemplateLiteralLoose(["\n        color: ", ";\n      "]);

  _templateObject18 = function _templateObject18() {
    return data;
  };

  return data;
}

function _templateObject17() {
  var data = _taggedTemplateLiteralLoose(["\n        box-shadow: ", " 0px 0px 0px 1px,\n          ", " 0px 0px 0px 3px;\n      "]);

  _templateObject17 = function _templateObject17() {
    return data;
  };

  return data;
}

function _templateObject16() {
  var data = _taggedTemplateLiteralLoose(["\n              box-shadow: inset 0 -2px 0 0 ", ";\n            "]);

  _templateObject16 = function _templateObject16() {
    return data;
  };

  return data;
}

function _templateObject15() {
  var data = _taggedTemplateLiteralLoose(["\n              box-shadow: inset -2px 0 0 0 ", ";\n            "]);

  _templateObject15 = function _templateObject15() {
    return data;
  };

  return data;
}

function _templateObject14() {
  var data = _taggedTemplateLiteralLoose(["\n        ", ";\n      "]);

  _templateObject14 = function _templateObject14() {
    return data;
  };

  return data;
}

function _templateObject13() {
  var data = _taggedTemplateLiteralLoose(["\n        background-color: ", ";\n        color: ", ";\n      "]);

  _templateObject13 = function _templateObject13() {
    return data;
  };

  return data;
}

function _templateObject12() {
  var data = _taggedTemplateLiteralLoose(["\n              border-bottom-color: ", ";\n            "]);

  _templateObject12 = function _templateObject12() {
    return data;
  };

  return data;
}

function _templateObject11() {
  var data = _taggedTemplateLiteralLoose(["\n              border-right-color: ", ";\n            "]);

  _templateObject11 = function _templateObject11() {
    return data;
  };

  return data;
}

function _templateObject10() {
  var data = _taggedTemplateLiteralLoose(["\n        border: 1px solid ", ";\n\n        ", ";\n      "]);

  _templateObject10 = function _templateObject10() {
    return data;
  };

  return data;
}

function _templateObject9() {
  var data = _taggedTemplateLiteralLoose(["\n              box-shadow: inset 0 -2px 0 0 ", ";\n            "]);

  _templateObject9 = function _templateObject9() {
    return data;
  };

  return data;
}

function _templateObject8() {
  var data = _taggedTemplateLiteralLoose(["\n              box-shadow: inset -2px 0 0 0 ", ";\n            "]);

  _templateObject8 = function _templateObject8() {
    return data;
  };

  return data;
}

function _templateObject7() {
  var data = _taggedTemplateLiteralLoose(["\n        background-color: ", ";\n\n        ", ";\n      "]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  var data = _taggedTemplateLiteralLoose(["\n            border-top-left-radius: ", ";\n            border-top-right-radius: ", ";\n\n            &:not(:last-child) {\n              margin-right: 0.5rem;\n            }\n          "]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = _taggedTemplateLiteralLoose(["\n            width: 100%;\n            border-top-left-radius: ", ";\n            border-bottom-left-radius: ", ";\n            margin-right: -2px;\n\n            &:not(:last-child) {\n              margin-bottom: 0.5rem;\n            }\n          "]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = _taggedTemplateLiteralLoose(["\n      border-radius: ", ";\n    "]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = _taggedTemplateLiteralLoose(["\n      border: 1px solid transparent;\n    "]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteralLoose(["\n      color: ", ";\n    "]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteralLoose(["\n  align-items: center;\n  cursor: pointer;\n  display: flex;\n  height: 2.75em;\n  justify-content: center;\n  margin-bottom: -1px;\n  padding: 0 1rem;\n  transition: box-shadow 0.1s ease-in-out 0s, background-color 0.1s, color 0.1s;\n\n  ", "\n\n  ", "\n\n  ", "\n\n    ", "\n\n  &[aria-selected='true'] {\n    color: ", ";\n    fill: ", ";\n\n    ", "\n\n    ", "\n\n    ", "\n\n    & {\n      ", ";\n    }\n  }\n\n  &:focus {\n    outline: unset;\n\n    ", "\n\n    ", "\n\n    & {\n      ", ";\n    }\n  }\n\n  &:not([aria-selected='true']):hover {\n    ", "\n\n    ", "\n\n    & {\n      ", ";\n    }\n  }\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var Tab = function Tab(styleProps) {
  return css(_templateObject(), styleProps.disabled && css$1(_templateObject2(), palette('gray300')(styleProps)), styleProps.variant === 'boxed' && css$1(_templateObject3()), styleProps.variant === 'button' && css$1(_templateObject4(), borderRadius('default')(styleProps)), styleProps.orientation === 'vertical' ? css$1(_templateObject5(), borderRadius('default')(styleProps), borderRadius('default')(styleProps)) : css$1(_templateObject6(), borderRadius('default')(styleProps), borderRadius('default')(styleProps)), palette(styleProps.palette, styleProps.palette)(styleProps), palette(styleProps.palette, styleProps.palette)(styleProps), styleProps.variant === 'default' && css$1(_templateObject7(), palette('background')(styleProps), styleProps.orientation === 'vertical' ? css$1(_templateObject8(), palette(styleProps.palette, styleProps.palette)(styleProps)) : css$1(_templateObject9(), palette(styleProps.palette, styleProps.palette)(styleProps))), styleProps.variant === 'boxed' && css$1(_templateObject10(), palette('white900')(styleProps), styleProps.orientation === 'vertical' ? css$1(_templateObject11(), palette('white')(styleProps)) : css$1(_templateObject12(), palette('white')(styleProps))), styleProps.variant === 'button' && css$1(_templateObject13(), palette(styleProps.palette, styleProps.palette)(styleProps), palette(styleProps.palette + "Inverted")(styleProps)), theme(styleProps.themeKey, "css.selected")(styleProps), styleProps.variant === 'default' && css$1(_templateObject14(), styleProps.orientation === 'vertical' ? css$1(_templateObject15(), palette(styleProps.palette, styleProps.palette)(styleProps)) : css$1(_templateObject16(), palette(styleProps.palette, styleProps.palette)(styleProps))), (styleProps.variant === 'boxed' || styleProps.variant === 'button') && css$1(_templateObject17(), palette(styleProps.palette, styleProps.palette)(styleProps), palette(styleProps.palette + "200")(styleProps)), theme(styleProps.themeKey, "css.focus")(styleProps), styleProps.variant !== 'button' && css$1(_templateObject18(), palette(styleProps.palette, styleProps.palette)(styleProps)), styleProps.variant === 'button' && css$1(_templateObject19(), palette('white700')(styleProps)), theme(styleProps.themeKey, "css.hover")(styleProps), theme(styleProps.themeKey, "css.root")(styleProps));
};
var Tabs = function Tabs(styleProps) {
  return css(_templateObject20(), styleProps.isFitted && css$1(_templateObject21()), styleProps.orientation === 'vertical' && css$1(_templateObject22()), theme(styleProps.themeKey, "css.root")(styleProps));
};
var TabsList = function TabsList(styleProps) {
  return css(_templateObject23(), fontWeight('semibold')(styleProps), styleProps.orientation === 'vertical' && css$1(_templateObject24()), (styleProps.variant === 'boxed' || styleProps.variant === 'default') && css$1(_templateObject25(), styleProps.orientation === 'vertical' ? css$1(_templateObject26(), palette('white900')(styleProps)) : css$1(_templateObject27(), palette('white900')(styleProps))), getAlignAttributes(styleProps), theme(styleProps.themeKey, "css.root")(styleProps));
};
var TabsPanel = function TabsPanel(styleProps) {
  return css(_templateObject28(), theme(styleProps.themeKey, "css.root")(styleProps));
};

function getAlignAttributes(styleProps) {
  var sizeAttributes = {
    left: css$1(_templateObject29(), theme(styleProps.themeKey, "css.align.left")(styleProps)),
    center: css$1(_templateObject30(), theme(styleProps.themeKey, "css.align.center")(styleProps)),
    right: css$1(_templateObject31(), theme(styleProps.themeKey, "css.align.right")(styleProps))
  };
  return sizeAttributes[styleProps.align || 'left'];
}

var styles = /*#__PURE__*/Object.freeze({
  Tab: Tab,
  Tabs: Tabs,
  TabsList: TabsList,
  TabsPanel: TabsPanel
});

export { Tab as T, Tabs as a, TabsList as b, TabsPanel as c, styles as s };
