'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../Provider/ThemeContext.js');
require('classnames');
require('emotion');
require('@emotion/core');
require('emotion-theming');
require('@emotion/styled');
require('../utils/useTheme.js');
var __chunk_1 = require('../chunk-4f52fe58.js');
require('lodash/kebabCase');
require('tinycolor2');
require('../utils/isFunction.js');
require('../utils/get.js');
require('../utils/theme.js');
require('../utils/omit.js');
require('../utils/pick.js');
var cssProps = require('../utils/cssProps.js');
require('../utils/useLocalStorage.js');
require('../Provider/ColorModeContext.js');
require('../utils/useColorMode.js');
var useStyle = require('../utils/useStyle.js');
require('../utils/omitBy.js');
require('../utils/useDefaultProps.js');
require('../utils/useDebounce.js');
require('lodash/uniq');
var useClassName = require('../utils/useClassName.js');
require('../utils/useBreakpoint.js');
require('../utils/uniqueId.js');
require('../utils/times.js');
require('../utils/parseIcons.js');
require('../utils/colors.js');
require('../utils/palette.js');
var mergeRefs = require('../utils/mergeRefs.js');
require('deepmerge');
require('lodash/set');
require('../utils/applyTheme.js');
require('../utils/bindFns.js');
var createComponent = require('../utils/createComponent.js');
var createElement = require('../utils/createElement.js');
var createHook = require('../utils/createHook.js');
require('../utils/forwardRefWithUse.js');
require('../utils/fieldAdaptors.js');
require('@emotion/is-prop-valid');
var htmlProps = require('../utils/htmlProps.js');
require('../utils/OutsideClickHandler.js');
var reakit = require('reakit');
var styles = require('./styles-efc98bd0.js');

var useProps = createHook.createHook(function (_props, _ref) {
  var themeKey = _ref.themeKey,
      themeKeyOverride = _ref.themeKeyOverride;
  var props = _props;
  var _props2 = props,
      use = _props2.use;

  if (use && typeof use !== 'string' && use.useProps) {
    var newProps = use.useProps(__chunk_1._objectSpread2(__chunk_1._objectSpread2({}, props), {}, {
      use: undefined
    }));
    props = __chunk_1._objectSpread2(__chunk_1._objectSpread2({}, props), newProps);
  } // Convert CSS props to an object.
  // Example input:
  // props = { color: 'red', backgroundColor: 'blue', isEnabled: true }
  //
  // Example output:
  // style = { color: 'red', backgroundColor: 'blue' }


  var style = useStyle.useStyle(props); // Append the styles from above as a className on the DOM element (with precedence).

  var className = useClassName.useClassName({
    style: styles.style,
    styleProps: __chunk_1._objectSpread2(__chunk_1._objectSpread2({}, props), {}, {
      style: style
    }),
    themeKey: themeKey,
    themeKeyOverride: themeKeyOverride,
    prevClassName: props.className
  }); // Append the Box styles as a className on the DOM element.

  className = useClassName.useClassName({
    style: styles.Box,
    styleProps: props,
    prevClassName: className,
    themeKey: themeKey,
    themeKeyOverride: themeKeyOverride
  }); // Pick out and invalid HTML props & omit the CSS props.

  var htmlProps$1 = cssProps.omitCSSProps(htmlProps.pickHTMLProps(__chunk_1._objectSpread2(__chunk_1._objectSpread2({}, props), {}, {
    className: className
  })));

  if (props.elementRef) {
    // @ts-ignore
    htmlProps$1.ref = mergeRefs.mergeRefs(props.elementRef, props.ref);
  }

  if (props.wrapElement) {
    // @ts-ignore
    htmlProps$1.wrapElement = props.wrapElement;
  }

  return __chunk_1._objectSpread2({}, htmlProps$1);
}, {
  themeKey: 'Box'
});
var Box = createComponent.createComponent(function (props) {
  var boxProps = useProps(props);
  return createElement.createElement({
    children: props.children,
    component: reakit.Box,
    use: props.use,
    htmlProps: boxProps
  });
}, {
  attach: {
    displayName: 'Box',
    useProps: useProps
  },
  themeKey: 'Box'
});

exports.Box = Box;
