'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
require('../Provider/ThemeContext.js');
require('classnames');
require('emotion');
require('@emotion/core');
require('emotion-theming');
require('@emotion/styled');
require('../utils/useTheme.js');
var __chunk_1 = require('../chunk-4f52fe58.js');
require('lodash/kebabCase');
require('tinycolor2');
require('../utils/isFunction.js');
require('../utils/get.js');
require('../utils/theme.js');
require('../utils/omit.js');
require('../utils/pick.js');
require('../utils/cssProps.js');
require('../utils/useLocalStorage.js');
require('../Provider/ColorModeContext.js');
require('../utils/useColorMode.js');
require('../utils/useStyle.js');
require('../utils/omitBy.js');
require('../utils/useDefaultProps.js');
require('../utils/useDebounce.js');
require('lodash/uniq');
var useClassName = require('../utils/useClassName.js');
require('../utils/useBreakpoint.js');
require('../utils/uniqueId.js');
require('../utils/times.js');
require('../utils/parseIcons.js');
require('../utils/colors.js');
require('../utils/palette.js');
require('../utils/mergeRefs.js');
require('deepmerge');
require('lodash/set');
require('../utils/applyTheme.js');
require('../utils/bindFns.js');
var createComponent = require('../utils/createComponent.js');
var createElement = require('../utils/createElement.js');
var createHook = require('../utils/createHook.js');
require('../utils/forwardRefWithUse.js');
require('../utils/fieldAdaptors.js');
require('@emotion/is-prop-valid');
require('../utils/htmlProps.js');
require('../utils/OutsideClickHandler.js');
require('../theme/palette.js');
var reakit = require('reakit');
var styles = require('./styles-ef2b3fee.js');
require('conditional-wrap');
require('../Box/styles-efc98bd0.js');
require('../Box/Box.js');
require('../Flex/styles-f03a673b.js');
require('../Flex/Flex.js');
require('../Icon/styles-5971248c.js');
var Icon = require('../Icon/Icon.js');
require('../Text/styles-778c8fc7.js');
require('../Text/Text.js');
require('../Spinner/styles-154c4cbf.js');
require('../Spinner/Spinner.js');
var Button = require('./Button.js');
var VisuallyHidden = require('reakit/VisuallyHidden');

var useProps = createHook.createHook(function (props, _ref) {
  var themeKey = _ref.themeKey,
      themeKeyOverride = _ref.themeKeyOverride;

  var iconProps = props.iconProps,
      label = props.label,
      restProps = __chunk_1._objectWithoutPropertiesLoose(props, ["iconProps", "label"]);

  var buttonProps = Button.Button.useProps(restProps);
  var className = useClassName.useClassName({
    style: styles.ButtonClose,
    styleProps: props,
    themeKey: themeKey,
    themeKeyOverride: themeKeyOverride,
    prevClassName: buttonProps.className
  });
  var children = /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Icon.Icon, __chunk_1._extends({
    fontSize: "300",
    icon: "close"
  }, iconProps)), /*#__PURE__*/React.createElement(VisuallyHidden.VisuallyHidden, null, label));
  return __chunk_1._objectSpread2(__chunk_1._objectSpread2({}, buttonProps), {}, {
    className: className,
    children: children
  });
}, {
  defaultProps: {
    label: 'Close',
    variant: 'ghost'
  },
  themeKey: 'Button.Close'
});
var ButtonClose = createComponent.createComponent(function (props) {
  var buttonCloseProps = useProps(props);
  return createElement.createElement({
    children: props.children,
    component: reakit.Button,
    use: props.use,
    htmlProps: buttonCloseProps
  });
}, {
  attach: {
    useProps: useProps,
    displayName: 'Button.Close'
  },
  themeKey: 'Button.Close'
});

exports.ButtonClose = ButtonClose;
