'use strict';

require('react');
require('../Provider/ThemeContext.js');
require('classnames');
var emotion = require('emotion');
var core = require('@emotion/core');
require('emotion-theming');
require('@emotion/styled');
require('../utils/useTheme.js');
var __chunk_1 = require('../chunk-4f52fe58.js');
require('lodash/kebabCase');
require('tinycolor2');
require('../utils/isFunction.js');
require('../utils/get.js');
var theme = require('../utils/theme.js');
require('../utils/omit.js');
require('../utils/pick.js');
require('../utils/cssProps.js');
require('../utils/useLocalStorage.js');
require('../Provider/ColorModeContext.js');
require('../utils/useColorMode.js');
require('../utils/useStyle.js');
require('../utils/omitBy.js');
require('../utils/useDefaultProps.js');
require('../utils/useDebounce.js');
require('lodash/uniq');
require('../utils/useClassName.js');
require('../utils/useBreakpoint.js');
require('../utils/uniqueId.js');
require('../utils/times.js');
require('../utils/parseIcons.js');
var colors = require('../utils/colors.js');
require('../utils/palette.js');
require('../utils/mergeRefs.js');
require('deepmerge');
require('lodash/set');
require('../utils/applyTheme.js');
require('../utils/bindFns.js');
require('../utils/createComponent.js');
require('../utils/createElement.js');
require('../utils/createHook.js');
require('../utils/forwardRefWithUse.js');
require('../utils/fieldAdaptors.js');
require('@emotion/is-prop-valid');
require('../utils/htmlProps.js');
require('../utils/OutsideClickHandler.js');
var palette$1 = require('../theme/palette.js');

function _templateObject23() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  & {\n    background-color: unset;\n    border: unset;\n    color: ", ";\n    fill: ", ";\n    box-shadow: unset;\n\n    &:hover {\n      background-color: rgba(0, 0, 0, 0.05);\n    }\n    &:hover:active {\n      background-color: rgba(0, 0, 0, 0.1);\n    }\n  }\n  & {\n    ", ";\n  }\n"]);

  _templateObject23 = function _templateObject23() {
    return data;
  };

  return data;
}

function _templateObject22() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      &:hover {\n        background-color: ", ";\n        color: ", ";\n        fill: ", ";\n      }\n    "]);

  _templateObject22 = function _templateObject22() {
    return data;
  };

  return data;
}

function _templateObject21() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  & {\n    background-color: unset;\n    border: 1px solid ", ";\n    color: ", ";\n    fill: ", ";\n    box-shadow: unset;\n\n    ", ";\n  }\n  & {\n    ", ";\n  }\n"]);

  _templateObject21 = function _templateObject21() {
    return data;
  };

  return data;
}

function _templateObject20() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  & {\n    border: 0;\n    background: unset;\n    color: ", ";\n    fill: ", ";\n    text-decoration: underline;\n    box-shadow: unset;\n\n    &:hover {\n      color: ", ";\n      fill: ", ";\n    }\n  }\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject20 = function _templateObject20() {
    return data;
  };

  return data;
}

function _templateObject19() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n    &:hover:active {\n      background-color: ", ";\n\n      & {\n        ", ";\n      }\n    }\n  "]);

  _templateObject19 = function _templateObject19() {
    return data;
  };

  return data;
}

function _templateObject18() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n    &:hover {\n      background-color: ", ";\n\n      & {\n        ", ";\n      }\n    }\n  "]);

  _templateObject18 = function _templateObject18() {
    return data;
  };

  return data;
}

function _templateObject17() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      border-color: transparent;\n    "]);

  _templateObject17 = function _templateObject17() {
    return data;
  };

  return data;
}

function _templateObject16() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  &:focus {\n    outline: unset;\n    z-index: 2;\n    box-shadow: ", " 0px 0px 0px\n        1px,\n      ", " 0px 0px 0px 3px;\n\n    ", ";\n\n    & {\n      ", ";\n    }\n  }\n\n  ", ";\n\n  ", ";\n"]);

  _templateObject16 = function _templateObject16() {
    return data;
  };

  return data;
}

function _templateObject15() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  & {\n    cursor: default;\n    outline: unset;\n\n    &:focus {\n      box-shadow: unset !important;\n      outline: unset !important;\n    }\n  }\n  & {\n    ", ";\n  }\n"]);

  _templateObject15 = function _templateObject15() {
    return data;
  };

  return data;
}

function _templateObject14() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  & {\n    cursor: not-allowed;\n    position: relative;\n\n    &:focus {\n      box-shadow: unset !important;\n      outline: unset !important;\n    }\n  }\n  & {\n    ", ";\n  }\n"]);

  _templateObject14 = function _templateObject14() {
    return data;
  };

  return data;
}

function _templateObject13() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      & {\n        font-size: ", "em;\n        min-height: 3.25rem;\n        padding: 0 ", "rem;\n      }\n      & {\n        ", ";\n      }\n    "]);

  _templateObject13 = function _templateObject13() {
    return data;
  };

  return data;
}

function _templateObject12() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      & {\n        min-height: 3rem;\n        padding: 0 ", "rem;\n      }\n      & {\n        ", ";\n      }\n    "]);

  _templateObject12 = function _templateObject12() {
    return data;
  };

  return data;
}

function _templateObject11() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      & {\n        ", ";\n      }\n    "]);

  _templateObject11 = function _templateObject11() {
    return data;
  };

  return data;
}

function _templateObject10() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      & {\n        font-size: ", "em;\n        min-height: 2rem;\n        padding: 0 ", "rem;\n      }\n      & {\n        ", ";\n      }\n    "]);

  _templateObject10 = function _templateObject10() {
    return data;
  };

  return data;
}

function _templateObject9() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  & {\n    cursor: not-allowed;\n    opacity: 0.7;\n    outline: unset;\n    pointer-events: unset;\n  }\n  & {\n    ", ";\n  }\n"]);

  _templateObject9 = function _templateObject9() {
    return data;
  };

  return data;
}

function _templateObject8() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  && {\n    min-height: unset;\n    padding: ", "em;\n  }\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject8 = function _templateObject8() {
    return data;
  };

  return data;
}

function _templateObject7() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  && {\n    font-size: 1.25em;\n  }\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  position: absolute;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n\n  & + .fp-Text {\n    opacity: 0;\n  }\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      margin-left: ", "em;\n      margin-right: -", "em;\n\n      & {\n        ", ";\n      }\n    "]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      margin-left: -", "em;\n      margin-right: ", "em;\n\n      & {\n        ", ";\n      }\n    "]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  ", ";\n\n  ", ";\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      border: 1px solid ", ";\n    "]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  align-items: center;\n  background-color: ", ";\n  border-radius: ", ";\n  box-shadow: 0 1px 3px 0px rgba(0, 0, 0, 0.05);\n  color: ", ";\n  fill: ", ";\n  cursor: pointer;\n  display: inline-flex;\n  font-weight: ", ";\n  min-height: 2.75rem;\n  justify-content: center;\n  padding: 0 ", "rem;\n  text-decoration: none;\n  hyphens: auto;\n  transition: box-shadow 0.1s ease-in-out 0s, border 0.1s, background-color 0.1s;\n\n  ", "\n\n  & {\n    ", ";\n  }\n\n  &[disabled],\n  &[aria-disabled=\"true\"] {\n    ", ";\n  }\n\n  ", "\n  ", ";\n  ", ";\n  ", ";\n\n  ", ";\n  ", ";\n  ", ";\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var defaultPalette = palette$1.default({});
var Button = function Button(styleProps) {
  return emotion.css(_templateObject(), theme.palette(styleProps.palette)(styleProps), theme.borderRadius('default')(styleProps), theme.palette(styleProps.palette + "Inverted")(styleProps), theme.palette(styleProps.palette + "Inverted")(styleProps), theme.fontWeight('semibold')(styleProps), theme.space(4)(styleProps), styleProps.palette === 'default' && core.css(_templateObject2(), theme.palette('white900')(styleProps)), theme.theme(styleProps.themeKey, "css.root")(styleProps), getDisabledProperties(styleProps), styleProps.size && getSizeProperties(styleProps), styleProps.isLoading && getLoadingProperties(styleProps), styleProps.isStatic && getStaticProperties(styleProps), isInteractive(styleProps) && getInteractiveProperties(styleProps), styleProps.variant === 'outlined' && getOutlinedProperties(styleProps), styleProps.variant === 'link' && getLinkProperties(styleProps), styleProps.variant === 'ghost' && getGhostProperties(styleProps));
};
var ButtonIcon = function ButtonIcon(styleProps) {
  return emotion.css(_templateObject3(), styleProps.isBefore && core.css(_templateObject4(), theme.space(1)(styleProps), theme.space(2)(styleProps), theme.theme(styleProps.themeKey, "css.before")(styleProps)), styleProps.isAfter && core.css(_templateObject5(), theme.space(2)(styleProps), theme.space(1)(styleProps), theme.theme(styleProps.themeKey, "css.after")(styleProps)), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var ButtonSpinnerWrapper = function ButtonSpinnerWrapper(styleProps) {
  return emotion.css(_templateObject6(), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var ButtonSpinner = function ButtonSpinner(styleProps) {
  return emotion.css(_templateObject7(), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var ButtonClose = function ButtonClose(styleProps) {
  return emotion.css(_templateObject8(), theme.space(2)(styleProps), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var isInteractive = function isInteractive(styleProps) {
  return !styleProps.isStatic && !styleProps.isLoading && !styleProps.disabled && styleProps.variant !== 'link';
};
var getDisabledProperties = function getDisabledProperties(styleProps) {
  return core.css(_templateObject9(), theme.theme(styleProps.themeKey, "css.disabled")(styleProps));
};
var getSizeProperties = function getSizeProperties(styleProps) {
  var styles = {
    small: core.css(_templateObject10(), theme.fontSize('100')(styleProps), theme.space(3)(styleProps), theme.theme(styleProps.themeKey, "css.sizes.small")(styleProps)),
    default: core.css(_templateObject11(), theme.theme(styleProps.themeKey, "css.sizes.default")(styleProps)),
    medium: core.css(_templateObject12(), theme.space(5)(styleProps), theme.theme(styleProps.themeKey, "css.sizes.medium")(styleProps)),
    large: core.css(_templateObject13(), theme.fontSize('300')(styleProps), theme.space(6)(styleProps), theme.theme(styleProps.themeKey, "css.sizes.large")(styleProps))
  };
  return styles[styleProps.size];
};
var getLoadingProperties = function getLoadingProperties(styleProps) {
  return core.css(_templateObject14(), theme.theme(styleProps.themeKey, "css.loading")(styleProps));
};
var getStaticProperties = function getStaticProperties(styleProps) {
  return core.css(_templateObject15(), theme.theme(styleProps.themeKey, "css.static")(styleProps));
};
var getInteractiveProperties = function getInteractiveProperties(styleProps) {
  return core.css(_templateObject16(), theme.palette(styleProps.palette === 'default' ? 'gray200' : styleProps.palette)(styleProps), theme.palette(styleProps.palette === 'default' ? 'gray100' : styleProps.palette + "200")(styleProps), styleProps.palette === 'default' && core.css(_templateObject17()), theme.theme(styleProps.themeKey, "css.focus")(styleProps), styleProps.variant !== 'link' && core.css(_templateObject18(), theme.palette((styleProps.palette === 'default' ? 'white' : styleProps.palette) + "600")(styleProps), theme.theme(styleProps.themeKey, "css.hover")(styleProps)), styleProps.variant !== 'link' && core.css(_templateObject19(), theme.palette(styleProps.palette === 'default' ? 'white800' : styleProps.palette + "700")(styleProps), theme.theme(styleProps.themeKey, "css.hoveractive")(styleProps)));
};
var getLinkProperties = function getLinkProperties(styleProps) {
  return core.css(_templateObject20(), styleProps.palette === 'default' ? theme.palette('text', defaultPalette.text)(styleProps) : theme.palette(styleProps.palette)(styleProps), styleProps.palette === 'default' ? theme.palette('text', defaultPalette.text)(styleProps) : theme.palette(styleProps.palette)(styleProps), styleProps.palette === 'default' ? colors.darken(0.4, 'text')(styleProps) : colors.darken(0.4, styleProps.palette)(styleProps), styleProps.palette === 'default' ? colors.darken(0.4, 'text')(styleProps) : colors.darken(0.4, styleProps.palette)(styleProps), theme.theme(styleProps.themeKey, "css.link")(styleProps));
};
var getOutlinedProperties = function getOutlinedProperties(styleProps) {
  return core.css(_templateObject21(), theme.palette()(styleProps), theme.palette()(styleProps), theme.palette()(styleProps), isInteractive(styleProps) && core.css(_templateObject22(), theme.palette()(styleProps), theme.palette(styleProps.palette + "Inverted")(styleProps), theme.palette(styleProps.palette + "Inverted")(styleProps)), theme.theme(styleProps.themeKey, "css.outlined")(styleProps));
};
var getGhostProperties = function getGhostProperties(styleProps) {
  return core.css(_templateObject23(), styleProps.palette === 'default' ? theme.palette('defaultInverted')(styleProps) : theme.palette()(styleProps), styleProps.palette === 'default' ? theme.palette('defaultInverted')(styleProps) : theme.palette()(styleProps), theme.theme(styleProps.themeKey, "css.ghost")(styleProps));
};

var styles = /*#__PURE__*/Object.freeze({
  Button: Button,
  ButtonIcon: ButtonIcon,
  ButtonSpinnerWrapper: ButtonSpinnerWrapper,
  ButtonSpinner: ButtonSpinner,
  ButtonClose: ButtonClose,
  isInteractive: isInteractive,
  getDisabledProperties: getDisabledProperties,
  getSizeProperties: getSizeProperties,
  getLoadingProperties: getLoadingProperties,
  getStaticProperties: getStaticProperties,
  getInteractiveProperties: getInteractiveProperties,
  getLinkProperties: getLinkProperties,
  getOutlinedProperties: getOutlinedProperties,
  getGhostProperties: getGhostProperties
});

exports.Button = Button;
exports.ButtonClose = ButtonClose;
exports.ButtonIcon = ButtonIcon;
exports.ButtonSpinner = ButtonSpinner;
exports.ButtonSpinnerWrapper = ButtonSpinnerWrapper;
exports.getDisabledProperties = getDisabledProperties;
exports.getGhostProperties = getGhostProperties;
exports.getInteractiveProperties = getInteractiveProperties;
exports.getLinkProperties = getLinkProperties;
exports.getLoadingProperties = getLoadingProperties;
exports.getOutlinedProperties = getOutlinedProperties;
exports.getSizeProperties = getSizeProperties;
exports.getStaticProperties = getStaticProperties;
exports.isInteractive = isInteractive;
exports.styles = styles;
