'use strict';

require('react');
require('../Provider/ThemeContext.js');
require('classnames');
var emotion = require('emotion');
var core = require('@emotion/core');
require('emotion-theming');
require('@emotion/styled');
require('../utils/useTheme.js');
var __chunk_1 = require('../chunk-4f52fe58.js');
require('lodash/kebabCase');
require('tinycolor2');
require('../utils/isFunction.js');
require('../utils/get.js');
var theme = require('../utils/theme.js');
require('../utils/omit.js');
require('../utils/pick.js');
require('../utils/cssProps.js');
require('../utils/useLocalStorage.js');
require('../Provider/ColorModeContext.js');
require('../utils/useColorMode.js');
require('../utils/useStyle.js');
require('../utils/omitBy.js');
require('../utils/useDefaultProps.js');
require('../utils/useDebounce.js');
require('lodash/uniq');
require('../utils/useClassName.js');
require('../utils/useBreakpoint.js');
require('../utils/uniqueId.js');
require('../utils/times.js');
require('../utils/parseIcons.js');
require('../utils/colors.js');
require('../utils/palette.js');
require('../utils/mergeRefs.js');
require('deepmerge');
require('lodash/set');
require('../utils/applyTheme.js');
require('../utils/bindFns.js');
require('../utils/createComponent.js');
require('../utils/createElement.js');
require('../utils/createHook.js');
require('../utils/forwardRefWithUse.js');
require('../utils/fieldAdaptors.js');
require('@emotion/is-prop-valid');
require('../utils/htmlProps.js');
require('../utils/OutsideClickHandler.js');
var getHiddenInputStyles = require('../utils/getHiddenInputStyles.js');

function _templateObject10() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  & {\n    ", ";\n  }\n"]);

  _templateObject10 = function _templateObject10() {
    return data;
  };

  return data;
}

function _templateObject9() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  & {\n    ", ";\n  }\n"]);

  _templateObject9 = function _templateObject9() {
    return data;
  };

  return data;
}

function _templateObject8() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  & {\n    ", ";\n  }\n"]);

  _templateObject8 = function _templateObject8() {
    return data;
  };

  return data;
}

function _templateObject7() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      border-color: ", ";\n    "]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n              border: 0.1rem solid ", ";\n              border-left-width: 0;\n              border-top-width: 0;\n              height: 0.625em;\n              transform: rotate(45deg);\n              width: 0.375em;\n            "]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n              background-color: ", ";\n              height: 0.125em;\n              width: 0.625em;\n              top: calc(50% - 0.0625em);\n              left: calc(50% - 0.3125em);\n            "]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      background-clip: padding-box;\n      content: '';\n      left: calc(50% - 0.1875em);\n      top: calc(50% - 0.375em);\n      position: absolute;\n\n      & {\n        ", ";\n      }\n    "]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  && {\n    font-weight: ", ";\n  }\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  -webkit-appearance: none;\n  background-color: ", ";\n  border: 1px solid #bdbdbd;\n  border-radius: 0.2em;\n  height: 1em;\n  position: relative;\n  min-width: 1em;\n  width: 1em;\n  transition: box-shadow 0.1s ease-in-out 0s, border-color 0.1s, background-color 0.1s;\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  && {\n    display: flex;\n    align-items: flex-start;\n  }\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var Checkbox = function Checkbox(styleProps) {
  return emotion.css(_templateObject(), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var CheckboxIcon = function CheckboxIcon(styleProps) {
  return emotion.css(_templateObject2(), theme.palette('background')(styleProps), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var CheckboxLabel = function CheckboxLabel(styleProps) {
  return emotion.css(_templateObject3(), theme.fontWeight('normal')(styleProps), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var HiddenCheckbox = function HiddenCheckbox(styleProps) {
  return getHiddenInputStyles.getHiddenInputStyles({
    iconClassName: 'fp-CheckboxIcon',
    checkedIconCss: core.css(_templateObject4(), styleProps.indeterminate ? core.css(_templateObject5(), theme.palette('primary')(styleProps)) : core.css(_templateObject6(), theme.palette('primary')(styleProps))),
    disabledCheckedIconCss: core.css(_templateObject7(), theme.palette('gray300')(styleProps)),
    styleProps: styleProps,
    themeKey: 'Checkbox.Icon'
  });
};
var CheckboxGroup = function CheckboxGroup(styleProps) {
  return emotion.css(_templateObject8(), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var CheckboxField = function CheckboxField(styleProps) {
  return emotion.css(_templateObject9(), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var CheckboxGroupField = function CheckboxGroupField(styleProps) {
  return emotion.css(_templateObject10(), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};

var styles = /*#__PURE__*/Object.freeze({
  Checkbox: Checkbox,
  CheckboxIcon: CheckboxIcon,
  CheckboxLabel: CheckboxLabel,
  HiddenCheckbox: HiddenCheckbox,
  CheckboxGroup: CheckboxGroup,
  CheckboxField: CheckboxField,
  CheckboxGroupField: CheckboxGroupField
});

exports.Checkbox = Checkbox;
exports.CheckboxField = CheckboxField;
exports.CheckboxGroup = CheckboxGroup;
exports.CheckboxGroupField = CheckboxGroupField;
exports.CheckboxIcon = CheckboxIcon;
exports.CheckboxLabel = CheckboxLabel;
exports.HiddenCheckbox = HiddenCheckbox;
exports.styles = styles;
