'use strict';

require('react');
require('../Provider/ThemeContext.js');
require('classnames');
var emotion = require('emotion');
var core = require('@emotion/core');
require('emotion-theming');
require('@emotion/styled');
require('../utils/useTheme.js');
var __chunk_1 = require('../chunk-4f52fe58.js');
require('lodash/kebabCase');
require('tinycolor2');
require('../utils/isFunction.js');
require('../utils/get.js');
var theme = require('../utils/theme.js');
require('../utils/omit.js');
require('../utils/pick.js');
require('../utils/cssProps.js');
require('../utils/useLocalStorage.js');
require('../Provider/ColorModeContext.js');
require('../utils/useColorMode.js');
require('../utils/useStyle.js');
require('../utils/omitBy.js');
require('../utils/useDefaultProps.js');
require('../utils/useDebounce.js');
require('lodash/uniq');
require('../utils/useClassName.js');
require('../utils/useBreakpoint.js');
require('../utils/uniqueId.js');
require('../utils/times.js');
require('../utils/parseIcons.js');
require('../utils/colors.js');
require('../utils/palette.js');
require('../utils/mergeRefs.js');
require('deepmerge');
require('lodash/set');
require('../utils/applyTheme.js');
require('../utils/bindFns.js');
require('../utils/createComponent.js');
require('../utils/createElement.js');
require('../utils/createHook.js');
require('../utils/forwardRefWithUse.js');
require('../utils/fieldAdaptors.js');
require('@emotion/is-prop-valid');
require('../utils/htmlProps.js');
require('../utils/OutsideClickHandler.js');

function _templateObject10() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  max-width: 600px;\n  width: 100%;\n\n  ", ";\n\n  & .fp-DialogContent {\n    max-height: 70vh;\n    overflow-y: ", ";\n  }\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject10 = function _templateObject10() {
    return data;
  };

  return data;
}

function _templateObject9() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  margin-right: ", "rem;\n\n  & .fp-Icon {\n    vertical-align: -0.125em;\n  }\n  & .fp-CalloutContent .fp-Icon {\n    font-size: 1.25em;\n  }\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject9 = function _templateObject9() {
    return data;
  };

  return data;
}

function _templateObject8() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  position: absolute;\n  top: ", "rem;\n  right: ", "rem;\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject8 = function _templateObject8() {
    return data;
  };

  return data;
}

function _templateObject7() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      justify-content: flex-end;\n    "]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      justify-content: space-between;\n    "]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  align-items: center;\n  background-color: ", ";\n  display: flex;\n  padding: ", "rem ", "rem;\n\n  ", ";\n\n  ", ";\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  font-size: ", "em;\n  font-weight: ", ";\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  margin-bottom: ", "rem;\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  display: flex;\n  padding: ", "rem;\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  border-radius: ", ";\n  background-color: ", ";\n  overflow: hidden;\n  position: relative;\n\n  ", ";\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var Dialog = function Dialog(styleProps) {
  return emotion.css(_templateObject(), theme.borderRadius('default')(styleProps), theme.palette('background')(styleProps), theme.altitude('100')(styleProps), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var DialogContent = function DialogContent(styleProps) {
  return emotion.css(_templateObject2(), theme.space(3, 'major')(styleProps), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var DialogHeader = function DialogHeader(styleProps) {
  return emotion.css(_templateObject3(), theme.space(2, 'major')(styleProps), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var DialogTitle = function DialogTitle(styleProps) {
  return emotion.css(_templateObject4(), theme.fontSize('300')(styleProps), theme.fontWeight('semibold')(styleProps), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var DialogFooter = function DialogFooter(styleProps) {
  return emotion.css(_templateObject5(), theme.palette('white600')(styleProps), theme.space(5, 'minor')(styleProps), theme.space(6, 'minor')(styleProps), styleProps.showActionButtons && styleProps.footer && core.css(_templateObject6()), styleProps.showActionButtons && !styleProps.footer && core.css(_templateObject7()), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var DialogClose = function DialogClose(styleProps) {
  return emotion.css(_templateObject8(), theme.space(2, 'major')(styleProps), theme.space(2, 'major')(styleProps), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var DialogIconWrapper = function DialogIconWrapper(styleProps) {
  return emotion.css(_templateObject9(), theme.space(2, 'major')(styleProps), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var DialogModal = function DialogModal(styleProps) {
  return emotion.css(_templateObject10(), theme.altitude('400')(styleProps), styleProps.hasScroll ? 'scroll' : 'visible', theme.theme(styleProps.themeKey, "css.root")(styleProps));
};

var styles = /*#__PURE__*/Object.freeze({
  Dialog: Dialog,
  DialogContent: DialogContent,
  DialogHeader: DialogHeader,
  DialogTitle: DialogTitle,
  DialogFooter: DialogFooter,
  DialogClose: DialogClose,
  DialogIconWrapper: DialogIconWrapper,
  DialogModal: DialogModal
});

exports.Dialog = Dialog;
exports.DialogClose = DialogClose;
exports.DialogContent = DialogContent;
exports.DialogFooter = DialogFooter;
exports.DialogHeader = DialogHeader;
exports.DialogIconWrapper = DialogIconWrapper;
exports.DialogModal = DialogModal;
exports.DialogTitle = DialogTitle;
exports.styles = styles;
