'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../Provider/ThemeContext.js');
require('classnames');
require('emotion');
require('@emotion/core');
require('emotion-theming');
require('@emotion/styled');
require('../utils/useTheme.js');
var __chunk_1 = require('../chunk-4f52fe58.js');
require('lodash/kebabCase');
require('tinycolor2');
require('../utils/isFunction.js');
require('../utils/get.js');
require('../utils/theme.js');
require('../utils/omit.js');
require('../utils/pick.js');
require('../utils/cssProps.js');
require('../utils/useLocalStorage.js');
require('../Provider/ColorModeContext.js');
require('../utils/useColorMode.js');
require('../utils/useStyle.js');
require('../utils/omitBy.js');
require('../utils/useDefaultProps.js');
require('../utils/useDebounce.js');
require('lodash/uniq');
var useClassName = require('../utils/useClassName.js');
require('../utils/useBreakpoint.js');
require('../utils/uniqueId.js');
require('../utils/times.js');
require('../utils/parseIcons.js');
require('../utils/colors.js');
require('../utils/palette.js');
require('../utils/mergeRefs.js');
require('deepmerge');
require('lodash/set');
require('../utils/applyTheme.js');
require('../utils/bindFns.js');
var createComponent = require('../utils/createComponent.js');
var createElement = require('../utils/createElement.js');
var createHook = require('../utils/createHook.js');
require('../utils/forwardRefWithUse.js');
require('../utils/fieldAdaptors.js');
require('@emotion/is-prop-valid');
require('../utils/htmlProps.js');
require('../utils/OutsideClickHandler.js');
var reakit = require('reakit');
require('../Box/styles-efc98bd0.js');
var Box = require('../Box/Box.js');
require('../Menu/styles-4fba2491.js');
var styles = require('./styles-18090575.js');

var useProps = createHook.createHook(function (props, _ref) {
  var themeKey = _ref.themeKey,
      themeKeyOverride = _ref.themeKeyOverride;

  var baseId = props.baseId,
      disabled = props.disabled,
      first = props.first,
      focusable = props.focusable,
      hide = props.hide,
      last = props.last,
      placement = props.placement,
      show = props.show,
      toggle = props.toggle,
      visible = props.visible,
      unstable_clickOnEnter = props.unstable_clickOnEnter,
      unstable_clickOnSpace = props.unstable_clickOnSpace,
      unstable_referenceRef = props.unstable_referenceRef,
      restProps = __chunk_1._objectWithoutPropertiesLoose(props, ["baseId", "disabled", "first", "focusable", "hide", "last", "placement", "show", "toggle", "visible", "unstable_clickOnEnter", "unstable_clickOnSpace", "unstable_referenceRef"]);

  var dropdownMenuDisclosureProps = reakit.useMenuDisclosure({
    baseId: baseId,
    disabled: disabled,
    first: first,
    focusable: focusable,
    hide: hide,
    last: last,
    placement: placement,
    show: show,
    toggle: toggle,
    visible: visible,
    unstable_clickOnEnter: unstable_clickOnEnter,
    unstable_clickOnSpace: unstable_clickOnSpace,
    unstable_referenceRef: unstable_referenceRef
  }, restProps);
  var boxProps = Box.Box.useProps(__chunk_1._objectSpread2(__chunk_1._objectSpread2({}, restProps), dropdownMenuDisclosureProps));
  var className = useClassName.useClassName({
    style: styles.DropdownMenuDisclosure,
    styleProps: props,
    themeKey: themeKey,
    themeKeyOverride: themeKeyOverride,
    prevClassName: boxProps.className
  });
  return __chunk_1._objectSpread2(__chunk_1._objectSpread2({}, boxProps), {}, {
    className: className
  });
}, {
  themeKey: 'DropdownMenu.Disclosure'
});
var DropdownMenuDisclosure = createComponent.createComponent(function (props) {
  var textProps = useProps(props);
  return createElement.createElement({
    children: props.children,
    component: reakit.Box,
    use: props.use,
    htmlProps: textProps
  });
}, {
  attach: {
    useProps: useProps,
    displayName: 'DropdownMenu.Disclosure'
  },
  themeKey: 'DropdownMenu.Disclosure'
});

exports.DropdownMenuDisclosure = DropdownMenuDisclosure;
