'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
require('../Provider/ThemeContext.js');
require('classnames');
require('emotion');
require('@emotion/core');
require('emotion-theming');
require('@emotion/styled');
require('../utils/useTheme.js');
var __chunk_1 = require('../chunk-4f52fe58.js');
require('lodash/kebabCase');
require('tinycolor2');
require('../utils/isFunction.js');
require('../utils/get.js');
require('../utils/theme.js');
require('../utils/omit.js');
require('../utils/pick.js');
require('../utils/cssProps.js');
require('../utils/useLocalStorage.js');
require('../Provider/ColorModeContext.js');
require('../utils/useColorMode.js');
require('../utils/useStyle.js');
require('../utils/omitBy.js');
require('../utils/useDefaultProps.js');
require('../utils/useDebounce.js');
require('lodash/uniq');
var useClassName = require('../utils/useClassName.js');
require('../utils/useBreakpoint.js');
var uniqueId = require('../utils/uniqueId.js');
require('../utils/times.js');
require('../utils/parseIcons.js');
require('../utils/colors.js');
require('../utils/palette.js');
require('../utils/mergeRefs.js');
require('deepmerge');
require('lodash/set');
require('../utils/applyTheme.js');
require('../utils/bindFns.js');
var createComponent = require('../utils/createComponent.js');
var createElement = require('../utils/createElement.js');
var createHook = require('../utils/createHook.js');
require('../utils/forwardRefWithUse.js');
require('../utils/fieldAdaptors.js');
require('@emotion/is-prop-valid');
require('../utils/htmlProps.js');
var OutsideClickHandler = require('../utils/OutsideClickHandler.js');
require('../theme/palette.js');
var reakit = require('reakit');
require('../Button/styles-ef2b3fee.js');
require('conditional-wrap');
require('../Box/styles-efc98bd0.js');
var Box = require('../Box/Box.js');
require('../Flex/styles-f03a673b.js');
require('../Flex/Flex.js');
require('../Icon/styles-5971248c.js');
var Icon = require('../Icon/Icon.js');
require('../Text/styles-778c8fc7.js');
var Text = require('../Text/Text.js');
require('../Spinner/styles-154c4cbf.js');
require('../Spinner/Spinner.js');
require('../Button/Button.js');
var VisuallyHidden = require('reakit/VisuallyHidden');
require('../Button/ButtonClose.js');
var index = require('../Button/index.js');
var styles = require('./styles-822385f1.js');
require('../Card/styles-60f2ca0e.js');
require('../Card/Card.js');
var index$1 = require('../Card/index.js');
require('../Disclosure/styles-27a9cebb.js');
require('../Disclosure/DisclosureState.js');
require('../Disclosure/Disclosure.js');
require('../Disclosure/DisclosureContent.js');
var index$2 = require('../Disclosure/index.js');
require('../Label/styles-bfcde1a2.js');
var Label = require('../Label/Label.js');

var useProps = createHook.createHook(function (props, _ref) {
  var themeKey = _ref.themeKey,
      themeKeyOverride = _ref.themeKeyOverride;

  var children = props.children,
      description = props.description,
      hint = props.hint,
      isOptional = props.isOptional,
      label = props.label,
      labelType = props.labelType,
      isRequired = props.isRequired,
      state = props.state,
      tooltip = props.tooltip,
      tooltipTriggerComponent = props.tooltipTriggerComponent,
      validationText = props.validationText,
      restProps = __chunk_1._objectWithoutPropertiesLoose(props, ["children", "description", "hint", "isOptional", "label", "labelType", "isRequired", "state", "tooltip", "tooltipTriggerComponent", "validationText"]);

  var boxProps = Box.Box.useProps(restProps);
  var className = useClassName.useClassName({
    style: styles.FieldWrapper,
    styleProps: props,
    themeKey: themeKey,
    themeKeyOverride: themeKeyOverride,
    prevClassName: boxProps.className
  });
  var labelClassName = useClassName.useClassName({
    style: styles.Label,
    styleProps: props,
    themeKey: themeKey,
    themeKeyOverride: themeKeyOverride,
    themeKeySuffix: 'Label'
  });
  var descriptionClassName = useClassName.useClassName({
    style: styles.DescriptionText,
    styleProps: props,
    themeKey: themeKey,
    themeKeyOverride: themeKeyOverride,
    themeKeySuffix: 'DescriptionText'
  });
  var hintClassName = useClassName.useClassName({
    style: styles.HintText,
    styleProps: props,
    themeKey: themeKey,
    themeKeyOverride: themeKeyOverride,
    themeKeySuffix: 'HintText'
  });
  var optionalClassName = useClassName.useClassName({
    style: styles.OptionalText,
    styleProps: props,
    themeKey: themeKey,
    themeKeySuffix: 'OptionalText'
  });
  var requiredClassName = useClassName.useClassName({
    style: styles.RequiredText,
    styleProps: props,
    themeKey: themeKey,
    themeKeySuffix: 'RequiredText'
  });
  var validationClassName = useClassName.useClassName({
    style: styles.ValidationText,
    styleProps: props,
    themeKey: themeKey,
    themeKeySuffix: 'ValidationText'
  });
  var tooltipTriggerClassName = useClassName.useClassName({
    style: styles.TooltipTrigger,
    styleProps: props,
    themeKey: themeKey,
    themeKeySuffix: 'TooltipTrigger'
  });
  var tooltipPopoverClassName = useClassName.useClassName({
    style: styles.TooltipPopover,
    styleProps: props,
    themeKey: themeKey,
    themeKeySuffix: 'TooltipPopover'
  });
  var disclosure = index$2.Disclosure.useState();
  var uid = uniqueId.useUniqueId('FieldWrapper');
  var elementProps = {
    isRequired: isRequired,
    id: uid,
    state: state
  };
  return __chunk_1._objectSpread2(__chunk_1._objectSpread2({}, boxProps), {}, {
    className: className,
    children: /*#__PURE__*/React.createElement(React.Fragment, null, label && /*#__PURE__*/React.createElement(Box.Box, {
      marginBottom: "minor-2"
    }, /*#__PURE__*/React.createElement(Box.Box, {
      display: "flex",
      alignItems: "center",
      lineHeight: "1"
    }, typeof label === 'string' ? /*#__PURE__*/React.createElement(React.Fragment, null, labelType === 'legend' ? /*#__PURE__*/React.createElement(Label.Label, {
      use: "legend",
      className: labelClassName
    }, label) :
    /*#__PURE__*/
    // @ts-ignore
    React.createElement(Label.Label, {
      className: labelClassName,
      htmlFor: uid
    }, label)) : label, isOptional && /*#__PURE__*/React.createElement(Box.Box, {
      className: optionalClassName
    }, "OPTIONAL"), isRequired && /*#__PURE__*/React.createElement(Box.Box, {
      className: requiredClassName
    }, "*"), tooltip && /*#__PURE__*/React.createElement(Box.Box, {
      position: "relative",
      marginLeft: "minor-2"
    }, /*#__PURE__*/React.createElement(OutsideClickHandler.OutsideClickHandler, {
      onOutsideClick: disclosure.hide
    }, tooltipTriggerComponent ? React.cloneElement(tooltipTriggerComponent, {
      onClick: disclosure.toggle
    }) : /*#__PURE__*/React.createElement(index.Button, {
      className: tooltipTriggerClassName,
      onClick: disclosure.toggle
    }, /*#__PURE__*/React.createElement(VisuallyHidden.VisuallyHidden, null, "Toggle tooltip"), /*#__PURE__*/React.createElement(Icon.Icon, {
      "aria-hidden": true,
      icon: "question-circle",
      verticalAlign: "-0.125rem"
    }))), disclosure.visible && /*#__PURE__*/React.createElement(index$1.Card, {
      className: tooltipPopoverClassName
    }, typeof tooltip === 'string' ? /*#__PURE__*/React.createElement(Text.Text, {
      fontSize: "150"
    }, tooltip) : tooltip))), description && /*#__PURE__*/React.createElement(Box.Box, {
      marginTop: "minor-1"
    }, typeof description === 'string' ? /*#__PURE__*/React.createElement(Box.Box, {
      className: descriptionClassName
    }, description) : description)), typeof children === 'function' ?
    /*
    // @ts-ignore */
    children({
      elementProps: elementProps
    }) : React.cloneElement(children, elementProps), hint && /*#__PURE__*/React.createElement(Box.Box, {
      marginTop: "minor-1"
    }, typeof hint === 'string' ? /*#__PURE__*/React.createElement(Box.Box, {
      className: hintClassName
    }, hint) : hint), validationText && /*#__PURE__*/React.createElement(Box.Box, {
      className: validationClassName,
      color: state
    }, validationText))
  });
}, {
  themeKey: 'FieldWrapper'
});
var FieldWrapper = createComponent.createComponent(function (props) {
  var textProps = useProps(props);
  return createElement.createElement({
    children: props.children,
    component: reakit.Box,
    enableRenderPropsComposition: false,
    use: props.use,
    htmlProps: textProps
  });
}, {
  attach: {
    useProps: useProps,
    displayName: 'FieldWrapper'
  },
  themeKey: 'FieldWrapper'
});

exports.FieldWrapper = FieldWrapper;
