'use strict';

require('react');
require('../Provider/ThemeContext.js');
require('classnames');
var emotion = require('emotion');
var core = require('@emotion/core');
require('emotion-theming');
require('@emotion/styled');
require('../utils/useTheme.js');
var __chunk_1 = require('../chunk-4f52fe58.js');
require('lodash/kebabCase');
require('tinycolor2');
require('../utils/isFunction.js');
require('../utils/get.js');
var theme = require('../utils/theme.js');
require('../utils/omit.js');
require('../utils/pick.js');
require('../utils/cssProps.js');
require('../utils/useLocalStorage.js');
require('../Provider/ColorModeContext.js');
require('../utils/useColorMode.js');
require('../utils/useStyle.js');
require('../utils/omitBy.js');
require('../utils/useDefaultProps.js');
require('../utils/useDebounce.js');
require('lodash/uniq');
require('../utils/useClassName.js');
require('../utils/useBreakpoint.js');
require('../utils/uniqueId.js');
require('../utils/times.js');
require('../utils/parseIcons.js');
require('../utils/colors.js');
require('../utils/palette.js');
require('../utils/mergeRefs.js');
require('deepmerge');
require('lodash/set');
require('../utils/applyTheme.js');
require('../utils/bindFns.js');
require('../utils/createComponent.js');
require('../utils/createElement.js');
require('../utils/createHook.js');
require('../utils/forwardRefWithUse.js');
require('../utils/fieldAdaptors.js');
require('@emotion/is-prop-valid');
require('../utils/htmlProps.js');
require('../utils/OutsideClickHandler.js');

function _templateObject23() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n                  border-left-width: 0;\n                "]);

  _templateObject23 = function _templateObject23() {
    return data;
  };

  return data;
}

function _templateObject22() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n                border-top-width: 0;\n              "]);

  _templateObject22 = function _templateObject22() {
    return data;
  };

  return data;
}

function _templateObject21() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n            ", ";\n          "]);

  _templateObject21 = function _templateObject21() {
    return data;
  };

  return data;
}

function _templateObject20() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n            border-top-width: 0;\n          "]);

  _templateObject20 = function _templateObject20() {
    return data;
  };

  return data;
}

function _templateObject19() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n                    border-top-left-radius: 0;\n                    border-bottom-left-radius: 0;\n                  "]);

  _templateObject19 = function _templateObject19() {
    return data;
  };

  return data;
}

function _templateObject18() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n                  border-top-left-radius: 0;\n                  border-top-right-radius: 0;\n                "]);

  _templateObject18 = function _templateObject18() {
    return data;
  };

  return data;
}

function _templateObject17() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n              ", ";\n            "]);

  _templateObject17 = function _templateObject17() {
    return data;
  };

  return data;
}

function _templateObject16() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n              border-top-left-radius: 0;\n              border-top-right-radius: 0;\n            "]);

  _templateObject16 = function _templateObject16() {
    return data;
  };

  return data;
}

function _templateObject15() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n        border-top-right-radius: 0;\n        border-top-left-radius: 0;\n        border-bottom-left-radius: ", ";\n      "]);

  _templateObject15 = function _templateObject15() {
    return data;
  };

  return data;
}

function _templateObject14() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n                  border-top-left-radius: 0;\n                  border-bottom-left-radius: 0;\n                "]);

  _templateObject14 = function _templateObject14() {
    return data;
  };

  return data;
}

function _templateObject13() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n                border-top-left-radius: 0;\n                border-top-right-radius: 0;\n              "]);

  _templateObject13 = function _templateObject13() {
    return data;
  };

  return data;
}

function _templateObject12() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n            ", ";\n          "]);

  _templateObject12 = function _templateObject12() {
    return data;
  };

  return data;
}

function _templateObject11() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n            border-top-right-radius: 0;\n            border-top-left-radius: 0;\n          "]);

  _templateObject11 = function _templateObject11() {
    return data;
  };

  return data;
}

function _templateObject10() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n                    border-bottom-right-radius: 0;\n                    border-top-right-radius: 0;\n                  "]);

  _templateObject10 = function _templateObject10() {
    return data;
  };

  return data;
}

function _templateObject9() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n                  border-bottom-right-radius: 0;\n                  border-bottom-left-radius: 0;\n                "]);

  _templateObject9 = function _templateObject9() {
    return data;
  };

  return data;
}

function _templateObject8() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n              ", ";\n            "]);

  _templateObject8 = function _templateObject8() {
    return data;
  };

  return data;
}

function _templateObject7() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n              border-bottom-right-radius: 0;\n              border-bottom-left-radius: 0;\n            "]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n                  border-bottom-right-radius: 0;\n                  border-top-right-radius: 0;\n                "]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n                border-bottom-right-radius: 0;\n                border-bottom-left-radius: 0;\n              "]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n            ", ";\n          "]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n            border-bottom-right-radius: 0;\n            border-bottom-left-radius: 0;\n          "]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      flex-direction: column;\n    "]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  display: flex;\n  flex-direction: ", ";\n\n  ", ";\n\n  & > * {\n    border-radius: ", ";\n    ", ";\n  }\n\n  & input:focus,\n  & select:focus {\n    z-index: 1;\n    position: relative;\n  }\n\n  & > *:first-child {\n    ", "\n\n    & input,\n    & select {\n      ", ";\n    }\n\n    ", ";\n  }\n\n  & > *:last-child {\n    ", "\n\n    ", ";\n\n    & input,\n    & select {\n      ", ";\n    }\n\n    ", ";\n  }\n\n  & > *:not(:first-child):not(:last-child),\n  & > *:not(:first-child):not(:last-child) > input,\n  & > *:not(:first-child):not(:last-child) > select {\n    border-radius: 0;\n    ", ";\n  }\n\n  & > *:not(:first-child) {\n    ", "\n  }\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var verticalBreakpoints = {
  tablet: 'mobile',
  desktop: 'tablet',
  widescreen: 'desktop',
  fullHD: 'widescreen'
};
var Group = function Group(styleProps) {
  return emotion.css(_templateObject(), styleProps.orientation === 'vertical' ? 'column' : 'row', theme.breakpoint(styleProps.verticalBelow ? "max-" + verticalBreakpoints[styleProps.verticalBelow] : null, core.css(_templateObject2()))(styleProps), theme.borderRadius(styleProps.borderRadius, styleProps.borderRadius)(styleProps), theme.theme(styleProps.themeKey, "Item.css.root")(styleProps), styleProps.orientation === 'vertical' ? core.css(_templateObject3()) : core.css(_templateObject4(), theme.breakpoint(styleProps.verticalBelow ? "max-" + verticalBreakpoints[styleProps.verticalBelow] : null, core.css(_templateObject5()), {
    else: core.css(_templateObject6())
  })(styleProps)), styleProps.orientation === 'vertical' ? core.css(_templateObject7()) : core.css(_templateObject8(), theme.breakpoint(styleProps.verticalBelow ? "max-" + verticalBreakpoints[styleProps.verticalBelow] : null, core.css(_templateObject9()), {
    else: core.css(_templateObject10())
  })(styleProps)), theme.theme(styleProps.themeKey, "Item.css.first")(styleProps), styleProps.orientation === 'vertical' ? core.css(_templateObject11()) : core.css(_templateObject12(), theme.breakpoint(styleProps.verticalBelow ? "max-" + verticalBreakpoints[styleProps.verticalBelow] : null, core.css(_templateObject13()), {
    else: core.css(_templateObject14())
  })(styleProps)), theme.breakpoint(styleProps.verticalBelow ? "max-" + verticalBreakpoints[styleProps.verticalBelow] : null, core.css(_templateObject15(), theme.borderRadius(styleProps.borderRadius, styleProps.borderRadius)(styleProps)))(styleProps), styleProps.orientation === 'vertical' ? core.css(_templateObject16()) : core.css(_templateObject17(), theme.breakpoint(styleProps.verticalBelow ? "max-" + verticalBreakpoints[styleProps.verticalBelow] : null, core.css(_templateObject18()), {
    else: core.css(_templateObject19())
  })(styleProps)), theme.theme(styleProps.themeKey, "Item.css.last")(styleProps), theme.theme(styleProps.themeKey, "Item.css.middle")(styleProps), styleProps.orientation === 'vertical' ? core.css(_templateObject20()) : core.css(_templateObject21(), theme.breakpoint(styleProps.verticalBelow ? "max-" + verticalBreakpoints[styleProps.verticalBelow] : null, core.css(_templateObject22()), {
    else: core.css(_templateObject23())
  })(styleProps)), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};

var styles = /*#__PURE__*/Object.freeze({
  Group: Group
});

exports.Group = Group;
exports.styles = styles;
