'use strict';

require('react');
require('../Provider/ThemeContext.js');
require('classnames');
var emotion = require('emotion');
require('@emotion/core');
require('emotion-theming');
require('@emotion/styled');
require('../utils/useTheme.js');
var __chunk_1 = require('../chunk-4f52fe58.js');
require('lodash/kebabCase');
require('tinycolor2');
require('../utils/isFunction.js');
require('../utils/get.js');
var theme = require('../utils/theme.js');
require('../utils/omit.js');
require('../utils/pick.js');
require('../utils/cssProps.js');
require('../utils/useLocalStorage.js');
require('../Provider/ColorModeContext.js');
require('../utils/useColorMode.js');
require('../utils/useStyle.js');
require('../utils/omitBy.js');
require('../utils/useDefaultProps.js');
require('../utils/useDebounce.js');
require('lodash/uniq');
require('../utils/useClassName.js');
require('../utils/useBreakpoint.js');
require('../utils/uniqueId.js');
require('../utils/times.js');
require('../utils/parseIcons.js');
require('../utils/colors.js');
require('../utils/palette.js');
require('../utils/mergeRefs.js');
require('deepmerge');
require('lodash/set');
require('../utils/applyTheme.js');
require('../utils/bindFns.js');
require('../utils/createComponent.js');
require('../utils/createElement.js');
require('../utils/createHook.js');
require('../utils/forwardRefWithUse.js');
require('../utils/fieldAdaptors.js');
require('@emotion/is-prop-valid');
require('../utils/htmlProps.js');
require('../utils/OutsideClickHandler.js');

function _templateObject2() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  font-weight: ", ";\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  font-family: ", ";\n  font-weight: ", ";\n  line-height: 1.2;\n\n  &:not(:last-child) {\n    margin-bottom: ", "rem;\n  }\n\n  .heading& + .sub-heading {\n    margin-top: -0.5em;\n  }\n\n  h1& {\n    font-size: ", "rem;\n    & {\n      ", ";\n    }\n  }\n  h2& {\n    font-size: ", "rem;\n    & {\n      ", ";\n    }\n  }\n  h3& {\n    font-size: ", "rem;\n    & {\n      ", ";\n    }\n  }\n  h4& {\n    font-size: ", "rem;\n    & {\n      ", ";\n    }\n  }\n  h5& {\n    font-size: ", "rem;\n    & {\n      ", ";\n    }\n  }\n  h6& {\n    font-size: ", "rem;\n    & {\n      ", ";\n    }\n  }\n\n  & {\n    ", ";\n  }\n\n  & .fp-Icon {\n    vertical-align: -0.125em;\n  }\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var Heading = function Heading(styleProps) {
  return emotion.css(_templateObject(), theme.font('heading')(styleProps), theme.fontWeight('bold')(styleProps), theme.space(4)(styleProps), theme.fontSize('700')(styleProps), theme.theme(styleProps.themeKey, "h1.css.root")(styleProps), theme.fontSize('600')(styleProps), theme.theme(styleProps.themeKey, "h2.css.root")(styleProps), theme.fontSize('500')(styleProps), theme.theme(styleProps.themeKey, "h3.css.root")(styleProps), theme.fontSize('400')(styleProps), theme.theme(styleProps.themeKey, "h4.css.root")(styleProps), theme.fontSize('300')(styleProps), theme.theme(styleProps.themeKey, "h5.css.root")(styleProps), theme.fontSize('200')(styleProps), theme.theme(styleProps.themeKey, "h6.css.root")(styleProps), styleProps.isSubHeading && getSubHeadingProperties(styleProps), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var getSubHeadingProperties = function getSubHeadingProperties(styleProps) {
  return emotion.css(_templateObject2(), theme.fontWeight('semibold')(styleProps), theme.theme(styleProps.themeKey, "subHeading.css.root")(styleProps));
};

var styles = /*#__PURE__*/Object.freeze({
  Heading: Heading,
  getSubHeadingProperties: getSubHeadingProperties
});

exports.Heading = Heading;
exports.getSubHeadingProperties = getSubHeadingProperties;
exports.styles = styles;
