'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
require('../Provider/ThemeContext.js');
require('classnames');
require('emotion');
require('@emotion/core');
require('emotion-theming');
require('@emotion/styled');
var useTheme = require('../utils/useTheme.js');
var __chunk_1 = require('../chunk-4f52fe58.js');
require('lodash/kebabCase');
require('tinycolor2');
require('../utils/isFunction.js');
require('../utils/get.js');
require('../utils/theme.js');
require('../utils/omit.js');
require('../utils/pick.js');
require('../utils/cssProps.js');
require('../utils/useLocalStorage.js');
require('../Provider/ColorModeContext.js');
require('../utils/useColorMode.js');
require('../utils/useStyle.js');
require('../utils/omitBy.js');
require('../utils/useDefaultProps.js');
require('../utils/useDebounce.js');
require('lodash/uniq');
var useClassName = require('../utils/useClassName.js');
require('../utils/useBreakpoint.js');
require('../utils/uniqueId.js');
require('../utils/times.js');
var parseIcons = require('../utils/parseIcons.js');
require('../utils/colors.js');
require('../utils/palette.js');
require('../utils/mergeRefs.js');
require('deepmerge');
require('lodash/set');
require('../utils/applyTheme.js');
require('../utils/bindFns.js');
var createComponent = require('../utils/createComponent.js');
var createElement = require('../utils/createElement.js');
var createHook = require('../utils/createHook.js');
require('../utils/forwardRefWithUse.js');
require('../utils/fieldAdaptors.js');
require('@emotion/is-prop-valid');
require('../utils/htmlProps.js');
require('../utils/OutsideClickHandler.js');
var reakit = require('reakit');
require('../Box/styles-efc98bd0.js');
var Box = require('../Box/Box.js');
var styles$1 = require('./styles-5971248c.js');

var useProps = createHook.createHook(function (props, _ref) {
  var _theme$Icon$iconNames, _theme$Icon, _theme$Icon$iconNames2, _theme$Icon$icons, _theme$Icon2;

  var themeKey = _ref.themeKey,
      themeKeyOverride = _ref.themeKeyOverride;
  var boxProps = Box.Box.useProps(props);
  var className = useClassName.useClassName({
    style: styles$1.Icon,
    styleProps: props,
    themeKey: themeKey,
    themeKeyOverride: themeKeyOverride,
    prevClassName: boxProps.className
  });

  var _useTheme = useTheme.useTheme(),
      theme = _useTheme.theme; // @ts-ignore


  var icon = (_theme$Icon$iconNames = theme === null || theme === void 0 ? void 0 : (_theme$Icon = theme.Icon) === null || _theme$Icon === void 0 ? void 0 : (_theme$Icon$iconNames2 = _theme$Icon.iconNames) === null || _theme$Icon$iconNames2 === void 0 ? void 0 : _theme$Icon$iconNames2[props.icon]) !== null && _theme$Icon$iconNames !== void 0 ? _theme$Icon$iconNames : props.icon;
  var icons = (_theme$Icon$icons = theme === null || theme === void 0 ? void 0 : (_theme$Icon2 = theme.Icon) === null || _theme$Icon2 === void 0 ? void 0 : _theme$Icon2.icons) !== null && _theme$Icon$icons !== void 0 ? _theme$Icon$icons : {};
  var iconInfo = icons[icon];

  if (props.type) {
    // @ts-ignore
    var parsedIcons = parseIcons.parseIcons([props.icon], {
      type: props.type
    });
    iconInfo = Object.entries(parsedIcons)[0][1];
  } else if (typeof props.icon === 'object') {
    iconInfo = props.icon;
  }

  var _ref2 = iconInfo || {},
      _ref2$viewBoxWidth = _ref2.viewBoxWidth,
      viewBoxWidth = _ref2$viewBoxWidth === void 0 ? 0 : _ref2$viewBoxWidth,
      _ref2$viewBoxHeight = _ref2.viewBoxHeight,
      viewBoxHeight = _ref2$viewBoxHeight === void 0 ? 0 : _ref2$viewBoxHeight,
      _ref2$paths = _ref2.paths,
      paths = _ref2$paths === void 0 ? [] : _ref2$paths;

  return __chunk_1._objectSpread2(__chunk_1._objectSpread2({
    role: 'img',
    viewBox: "0 0 " + viewBoxWidth + " " + viewBoxHeight
  }, boxProps), {}, {
    className: className,
    children: /*#__PURE__*/React.createElement(React.Fragment, null, props.label && /*#__PURE__*/React.createElement("title", null, props.label), paths.map(function (path) {
      return /*#__PURE__*/React.createElement("path", {
        key: path,
        d: path,
        fill: "currentColor",
        fillRule: "evenodd"
      });
    }))
  });
}, {
  themeKey: 'Icon'
});
var Icon = createComponent.createComponent(function (props) {
  var iconProps = useProps(props);
  return createElement.createElement({
    children: props.children,
    component: reakit.Box,
    use: props.use,
    htmlProps: iconProps
  });
}, {
  attach: {
    useProps: useProps,
    displayName: 'Icon'
  },
  defaultProps: {
    use: 'svg'
  },
  themeKey: 'Icon'
});

exports.Icon = Icon;
