'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
require('../Provider/ThemeContext.js');
require('classnames');
require('emotion');
require('@emotion/core');
require('emotion-theming');
require('@emotion/styled');
require('../utils/useTheme.js');
var __chunk_1 = require('../chunk-4f52fe58.js');
require('lodash/kebabCase');
require('tinycolor2');
require('../utils/isFunction.js');
require('../utils/get.js');
require('../utils/theme.js');
require('../utils/omit.js');
require('../utils/pick.js');
require('../utils/cssProps.js');
require('../utils/useLocalStorage.js');
require('../Provider/ColorModeContext.js');
require('../utils/useColorMode.js');
require('../utils/useStyle.js');
require('../utils/omitBy.js');
require('../utils/useDefaultProps.js');
require('../utils/useDebounce.js');
require('lodash/uniq');
var useClassName = require('../utils/useClassName.js');
require('../utils/useBreakpoint.js');
require('../utils/uniqueId.js');
require('../utils/times.js');
require('../utils/parseIcons.js');
require('../utils/colors.js');
require('../utils/palette.js');
require('../utils/mergeRefs.js');
require('deepmerge');
require('lodash/set');
require('../utils/applyTheme.js');
require('../utils/bindFns.js');
var createComponent = require('../utils/createComponent.js');
var createElement = require('../utils/createElement.js');
var createHook = require('../utils/createHook.js');
require('../utils/forwardRefWithUse.js');
require('../utils/fieldAdaptors.js');
require('@emotion/is-prop-valid');
require('../utils/htmlProps.js');
require('../utils/OutsideClickHandler.js');
var reakit = require('reakit');
require('../Box/styles-efc98bd0.js');
require('../Box/Box.js');
var styles$1$5 = require('./styles-4fba2491.js');
require('../Divider/styles-b2716364.js');
var Divider = require('../Divider/Divider.js');
require('../Rover/styles-c38fc9d1.js');
require('../Rover/RoverState.js');
require('../Rover/Rover.js');
require('../Rover/index.js');
var Menu = require('./Menu.js');

var useProps = createHook.createHook(function (props, _ref) {
  var themeKey = _ref.themeKey,
      themeKeyOverride = _ref.themeKeyOverride;

  var orientation = props.orientation,
      overrides = props.overrides,
      restProps = __chunk_1._objectWithoutPropertiesLoose(props, ["orientation", "overrides"]);

  var _React$useContext = React.useContext(Menu.MenuContext),
      menuOverrides = _React$useContext.overrides;

  var MenuDividerProps = reakit.useMenuSeparator({
    orientation: orientation
  }, restProps);
  var dividerProps = Divider.Divider.useProps(__chunk_1._objectSpread2(__chunk_1._objectSpread2({}, restProps), MenuDividerProps));
  var className = useClassName.useClassName({
    style: styles$1$5.MenuDivider,
    styleProps: __chunk_1._objectSpread2(__chunk_1._objectSpread2({}, props), {}, {
      overrides: __chunk_1._objectSpread2(__chunk_1._objectSpread2({}, menuOverrides), {}, {
        overrides: overrides
      })
    }),
    themeKey: themeKey,
    themeKeyOverride: themeKeyOverride,
    prevClassName: dividerProps.className
  });
  return __chunk_1._objectSpread2(__chunk_1._objectSpread2({}, dividerProps), {}, {
    role: 'separator',
    className: className
  });
}, {
  themeKey: 'Menu.Divider'
});
var MenuDivider = createComponent.createComponent(function (props) {
  var textProps = useProps(props);
  return createElement.createElement({
    children: props.children,
    component: reakit.Box,
    use: props.use,
    htmlProps: textProps
  });
}, {
  attach: {
    useProps: useProps,
    displayName: 'Menu.Divider'
  },
  themeKey: 'Menu.Divider'
});

exports.MenuDivider = MenuDivider;
