'use strict';

require('react');
require('../Provider/ThemeContext.js');
require('classnames');
var emotion = require('emotion');
var core = require('@emotion/core');
require('emotion-theming');
require('@emotion/styled');
require('../utils/useTheme.js');
var __chunk_1 = require('../chunk-4f52fe58.js');
require('lodash/kebabCase');
require('tinycolor2');
require('../utils/isFunction.js');
require('../utils/get.js');
var theme = require('../utils/theme.js');
require('../utils/omit.js');
require('../utils/pick.js');
require('../utils/cssProps.js');
require('../utils/useLocalStorage.js');
require('../Provider/ColorModeContext.js');
require('../utils/useColorMode.js');
require('../utils/useStyle.js');
require('../utils/omitBy.js');
require('../utils/useDefaultProps.js');
require('../utils/useDebounce.js');
require('lodash/uniq');
require('../utils/useClassName.js');
require('../utils/useBreakpoint.js');
require('../utils/uniqueId.js');
require('../utils/times.js');
require('../utils/parseIcons.js');
require('../utils/colors.js');
require('../utils/palette.js');
require('../utils/mergeRefs.js');
require('deepmerge');
require('lodash/set');
require('../utils/applyTheme.js');
require('../utils/bindFns.js');
require('../utils/createComponent.js');
require('../utils/createElement.js');
require('../utils/createHook.js');
require('../utils/forwardRefWithUse.js');
require('../utils/fieldAdaptors.js');
require('@emotion/is-prop-valid');
require('../utils/htmlProps.js');
require('../utils/OutsideClickHandler.js');

function _templateObject9() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  color: ", ";\n  font-size: ", "rem;\n  font-weight: ", ";\n  letter-spacing: 1px;\n  padding: ", "rem ", "rem;\n  padding-top: ", "rem;\n  text-transform: uppercase;\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject9 = function _templateObject9() {
    return data;
  };

  return data;
}

function _templateObject8() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  & {\n    ", ";\n  }\n"]);

  _templateObject8 = function _templateObject8() {
    return data;
  };

  return data;
}

function _templateObject7() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  && {\n    margin: ", "rem 0;\n  }\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      margin-left: ", "rem;\n    "]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      margin-right: ", "rem;\n    "]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  ", "\n  ", "\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      background-color: ", ";\n\n      &&:hover,\n      &&:focus {\n        background-color: ", ";\n      }\n\n      & {\n        ", ";\n      }\n    "]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  background-color: unset;\n  cursor: pointer;\n  display: block;\n  font-weight: ", ";\n  padding: ", "rem ", "rem;\n  text-align: left;\n  width: 100%;\n  transition: background-color 0.1s;\n\n  a& {\n    color: unset;\n    fill: unset;\n    text-decoration: unset;\n\n    &:hover {\n      color: unset;\n      fill: unset;\n    }\n  }\n\n  &[disabled] {\n    cursor: not-allowed;\n    opacity: 0.5;\n\n    & {\n      ", ";\n    }\n  }\n\n  &:not(:disabled):focus {\n    outline: unset;\n    background-color: ", ";\n\n    & {\n      ", ";\n    }\n  }\n  &:not(:disabled):hover {\n    background-color: ", ";\n\n    & {\n      ", ";\n    }\n  }\n  &:not(:disabled):focus:active,\n  &:not(:disabled):hover:active {\n    background-color: ", ";\n  }\n\n  ", "\n\n  & .fp-Icon {\n    vertical-align: -0.125em;\n  }\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  padding: ", "rem 0;\n  width: 100%;\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var Menu = function Menu(styleProps) {
  return emotion.css(_templateObject(), theme.space(2)(styleProps), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var MenuItem = function MenuItem(styleProps) {
  return emotion.css(_templateObject2(), theme.fontWeight('semibold')(styleProps), theme.space(1.5)(styleProps), theme.space(4)(styleProps), theme.theme(styleProps.themeKey, "disabled")(styleProps), theme.palette('white600')(styleProps), theme.theme(styleProps.themeKey, "focus")(styleProps), theme.palette('white600')(styleProps), theme.theme(styleProps.themeKey, "hover")(styleProps), theme.palette('white700')(styleProps), styleProps.isActive && core.css(_templateObject3(), theme.palette('white700')(styleProps), theme.palette('white800')(styleProps), theme.theme(styleProps.themeKey, "active")(styleProps)), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var MenuItemIcon = function MenuItemIcon(styleProps) {
  return emotion.css(_templateObject4(), styleProps.isBefore && core.css(_templateObject5(), theme.space(2)(styleProps)), styleProps.isAfter && core.css(_templateObject6(), theme.space(2)(styleProps)), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var MenuDivider = function MenuDivider(styleProps) {
  return emotion.css(_templateObject7(), theme.space(2)(styleProps), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var MenuGroup = function MenuGroup(styleProps) {
  return emotion.css(_templateObject8(), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var MenuGroupTitle = function MenuGroupTitle(styleProps) {
  return emotion.css(_templateObject9(), theme.palette('text200')(styleProps), theme.fontSize('100')(styleProps), theme.fontWeight('semibold')(styleProps), theme.space(2)(styleProps), theme.space(4)(styleProps), theme.space(1)(styleProps), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};

var styles = /*#__PURE__*/Object.freeze({
  Menu: Menu,
  MenuItem: MenuItem,
  MenuItemIcon: MenuItemIcon,
  MenuDivider: MenuDivider,
  MenuGroup: MenuGroup,
  MenuGroupTitle: MenuGroupTitle
});

exports.Menu = Menu;
exports.MenuDivider = MenuDivider;
exports.MenuGroup = MenuGroup;
exports.MenuGroupTitle = MenuGroupTitle;
exports.MenuItem = MenuItem;
exports.MenuItemIcon = MenuItemIcon;
exports.styles = styles;
