'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../Provider/ThemeContext.js');
require('classnames');
require('emotion');
require('@emotion/core');
require('emotion-theming');
require('@emotion/styled');
require('../utils/useTheme.js');
var __chunk_1 = require('../chunk-4f52fe58.js');
require('lodash/kebabCase');
require('tinycolor2');
require('../utils/isFunction.js');
require('../utils/get.js');
require('../utils/theme.js');
require('../utils/omit.js');
require('../utils/pick.js');
require('../utils/cssProps.js');
require('../utils/useLocalStorage.js');
require('../Provider/ColorModeContext.js');
require('../utils/useColorMode.js');
require('../utils/useStyle.js');
require('../utils/omitBy.js');
require('../utils/useDefaultProps.js');
require('../utils/useDebounce.js');
require('lodash/uniq');
var useClassName = require('../utils/useClassName.js');
require('../utils/useBreakpoint.js');
require('../utils/uniqueId.js');
require('../utils/times.js');
require('../utils/parseIcons.js');
require('../utils/colors.js');
require('../utils/palette.js');
require('../utils/mergeRefs.js');
require('deepmerge');
require('lodash/set');
require('../utils/applyTheme.js');
require('../utils/bindFns.js');
var createComponent = require('../utils/createComponent.js');
var createElement = require('../utils/createElement.js');
var createHook = require('../utils/createHook.js');
require('../utils/forwardRefWithUse.js');
require('../utils/fieldAdaptors.js');
require('@emotion/is-prop-valid');
require('../utils/htmlProps.js');
require('../utils/OutsideClickHandler.js');
var reakit = require('reakit');
require('../Box/styles-efc98bd0.js');
require('../Box/Box.js');
require('../Disclosure/styles-27a9cebb.js');
require('../Disclosure/DisclosureState.js');
require('../Disclosure/Disclosure.js');
require('../Disclosure/DisclosureContent.js');
var index$2 = require('../Disclosure/index.js');
require('../Modal/styles-b6bbf6b0.js');
require('../Modal/ModalState.js');
require('../Modal/ModalBackdrop.js');
require('../Modal/Modal.js');
require('../Modal/ModalDisclosure.js');
require('../Modal/index.js');
require('../Drawer/styles-7978f8ea.js');
require('../Drawer/Drawer.js');
require('../Drawer/DrawerDisclosure.js');
require('../Drawer/DrawerState.js');
require('../Drawer/index.js');
var styles$1 = require('./styles-0dcd922b.js');
require('./PageContext.js');
var usePage = require('./usePage.js');

var useProps = createHook.createHook(function (props, _ref) {
  var themeKey = _ref.themeKey,
      themeKeyOverride = _ref.themeKeyOverride;
  var page = usePage.usePage();
  var htmlProps = index$2.Disclosure.useProps(__chunk_1._objectSpread2(__chunk_1._objectSpread2({}, props), page.header.disclosure));
  var className = useClassName.useClassName({
    style: styles$1.PageWithHeaderDisclosure,
    styleProps: props,
    themeKey: themeKey,
    themeKeyOverride: themeKeyOverride,
    prevClassName: htmlProps.className
  });
  return __chunk_1._objectSpread2(__chunk_1._objectSpread2({}, htmlProps), {}, {
    className: className
  });
}, {
  themeKey: 'PageWithHeader.Disclosure'
});
var PageWithHeaderDisclosure = createComponent.createComponent(function (props) {
  var PageWithHeaderDisclosureProps = useProps(props);
  return createElement.createElement({
    children: props.children,
    component: reakit.Box,
    use: props.use,
    htmlProps: PageWithHeaderDisclosureProps
  });
}, {
  attach: {
    useProps: useProps,
    displayName: 'PageWithHeader.Disclosure'
  },
  defaultProps: {
    use: 'button'
  },
  themeKey: 'PageWithHeader.Disclosure'
});

exports.PageWithHeaderDisclosure = PageWithHeaderDisclosure;
