'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
require('../Provider/ThemeContext.js');
require('classnames');
require('emotion');
require('@emotion/core');
require('emotion-theming');
require('@emotion/styled');
require('../utils/useTheme.js');
var __chunk_1 = require('../chunk-4f52fe58.js');
require('lodash/kebabCase');
require('tinycolor2');
var isFunction = require('../utils/isFunction.js');
require('../utils/get.js');
require('../utils/theme.js');
require('../utils/omit.js');
require('../utils/pick.js');
require('../utils/cssProps.js');
require('../utils/useLocalStorage.js');
require('../Provider/ColorModeContext.js');
require('../utils/useColorMode.js');
require('../utils/useStyle.js');
require('../utils/omitBy.js');
require('../utils/useDefaultProps.js');
require('../utils/useDebounce.js');
require('lodash/uniq');
require('../utils/useClassName.js');
require('../utils/useBreakpoint.js');
require('../utils/uniqueId.js');
require('../utils/times.js');
require('../utils/parseIcons.js');
require('../utils/colors.js');
require('../utils/palette.js');
require('../utils/mergeRefs.js');
require('deepmerge');
require('lodash/set');
require('../utils/applyTheme.js');
require('../utils/bindFns.js');
require('../utils/createComponent.js');
require('../utils/createElement.js');
require('../utils/createHook.js');
require('../utils/forwardRefWithUse.js');
require('../utils/fieldAdaptors.js');
require('@emotion/is-prop-valid');
require('../utils/htmlProps.js');
require('../utils/OutsideClickHandler.js');
var reakit = require('reakit');

var PopoverStateContext = React.createContext({
  popover: {}
});
function usePopoverState(initialState) {
  return reakit.usePopoverState(initialState);
}
function PopoverState(props) {
  var children = props.children,
      restProps = __chunk_1._objectWithoutPropertiesLoose(props, ["children"]);

  var popover = usePopoverState(restProps);
  var contextValue = React.useMemo(function () {
    return {
      popover: popover
    };
  }, [popover]);
  return /*#__PURE__*/React.createElement(PopoverStateContext.Provider, {
    value: contextValue
  }, isFunction.isFunction(props.children) ? props.children(popover) : props.children);
}

exports.PopoverState = PopoverState;
exports.PopoverStateContext = PopoverStateContext;
exports.usePopoverState = usePopoverState;
