'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var ThemeContext = require('./ThemeContext.js');
require('classnames');
require('emotion');
require('@emotion/core');
var emotionTheming = require('emotion-theming');
require('@emotion/styled');
require('../utils/useTheme.js');
require('../chunk-4f52fe58.js');
require('lodash/kebabCase');
require('tinycolor2');
require('../utils/isFunction.js');
require('../utils/get.js');
require('../utils/theme.js');
require('../utils/omit.js');
require('../utils/pick.js');
require('../utils/cssProps.js');
require('../utils/useLocalStorage.js');
var ColorModeContext = require('./ColorModeContext.js');
require('../utils/useColorMode.js');
require('../utils/useStyle.js');
require('../utils/omitBy.js');
require('../utils/useDefaultProps.js');
require('../utils/useDebounce.js');
require('lodash/uniq');
require('../utils/useClassName.js');
require('../utils/useBreakpoint.js');
var uniqueId = require('../utils/uniqueId.js');
require('../utils/times.js');
require('../utils/parseIcons.js');
require('../utils/colors.js');
require('../utils/palette.js');
require('../utils/mergeRefs.js');
require('deepmerge');
require('lodash/set');
require('../utils/applyTheme.js');
require('../utils/bindFns.js');
require('../utils/createComponent.js');
require('../utils/createElement.js');
require('../utils/createHook.js');
require('../utils/forwardRefWithUse.js');
require('../utils/fieldAdaptors.js');
require('@emotion/is-prop-valid');
require('../utils/htmlProps.js');
require('../utils/OutsideClickHandler.js');
require('../theme/spacing.js');
require('../theme/palette.js');
require('../theme/modes.js');
require('../theme/altitudes.js');
require('../theme/borders.js');
require('../theme/borderRadii.js');
require('../theme/breakpoints.js');
require('../theme/global.js');
require('../theme/fonts.js');
require('../theme/fontWeights.js');
require('../theme/fontSizes.js');
require('../theme/Container.js');
require('@fortawesome/free-solid-svg-icons/faInfoCircle');
require('@fortawesome/free-solid-svg-icons/faChevronDown');
require('@fortawesome/free-solid-svg-icons/faChevronLeft');
require('@fortawesome/free-solid-svg-icons/faChevronRight');
require('@fortawesome/free-solid-svg-icons/faExclamationTriangle');
require('@fortawesome/free-solid-svg-icons/faCheckCircle');
require('@fortawesome/free-solid-svg-icons/faExclamationCircle');
require('@fortawesome/free-solid-svg-icons/faQuestionCircle');
require('@fortawesome/free-solid-svg-icons/faTimes');
require('@fortawesome/free-solid-svg-icons/faSearch');
require('@fortawesome/free-solid-svg-icons/faStar');
require('../theme/Icon.js');
require('../theme/Toast.js');
var index = require('../theme/index.js');
require('reakit');
require('../Button/styles-ef2b3fee.js');
require('conditional-wrap');
require('../Box/styles-efc98bd0.js');
var Box = require('../Box/Box.js');
require('../Flex/styles-f03a673b.js');
require('../Flex/Flex.js');
require('../Icon/styles-5971248c.js');
require('../Icon/Icon.js');
require('../Text/styles-778c8fc7.js');
require('../Text/Text.js');
require('../Spinner/styles-154c4cbf.js');
require('../Spinner/Spinner.js');
require('../Button/Button.js');
require('reakit/VisuallyHidden');
require('../Button/ButtonClose.js');
require('../Button/index.js');
require('../Alert/styles-6efb7d2c.js');
require('../Alert/Alert.js');
require('../Alert/index.js');
require('../Disclosure/styles-27a9cebb.js');
require('../Disclosure/DisclosureState.js');
require('../Disclosure/Disclosure.js');
require('../Disclosure/DisclosureContent.js');
require('../Disclosure/index.js');
require('../Modal/styles-b6bbf6b0.js');
require('../Modal/ModalState.js');
require('../Modal/ModalBackdrop.js');
require('../Modal/Modal.js');
require('../Modal/ModalDisclosure.js');
require('../Modal/index.js');
require('../Overlay/styles-00c6c1d9.js');
require('../Overlay/Overlay.js');
require('../Overlay/OverlayDisclosure.js');
require('../Overlay/OverlayState.js');
require('../Overlay/index.js');
require('../Drawer/styles-7978f8ea.js');
require('../Drawer/Drawer.js');
require('../Drawer/DrawerDisclosure.js');
require('../Drawer/DrawerState.js');
require('../Drawer/index.js');
require('../Stack/styles-3b5f2587.js');
require('../Stack/Stack.js');
require('../Page/styles-0dcd922b.js');
var PageContext = require('../Page/PageContext.js');
require('../Toast/styles-4fe5ff95.js');
require('../Toast/Toast.js');
var ToastContext = require('../Toast/ToastContext.js');
require('../Toast/ToastManager.js');
require('../Toast/index.js');
var GlobalStyles = require('./GlobalStyles.js');

Provider.defaultProps = {
  colorMode: 'default'
};
function Provider(props) {
  var children = props.children,
      colorMode = props.colorMode,
      collapseBelow = props.collapseBelow,
      isStandalone = props.isStandalone,
      _theme = props.theme; ////////////////////////////////////////////////

  var _React$useState = React.useState(_theme),
      theme = _React$useState[0],
      setTheme = _React$useState[1];

  React.useEffect(function () {
    setTheme(_theme);
  }, [_theme]); ////////////////////////////////////////////////

  var derivedTheme = React.useMemo(function () {
    if (theme && isStandalone) {
      return theme;
    }

    return index.default(theme);
  }, [isStandalone, theme]); ////////////////////////////////////////////////

  var themeContextValue = React.useMemo(function () {
    return {
      theme: theme,
      setTheme: setTheme
    };
  }, [theme, setTheme]); ////////////////////////////////////////////////

  return /*#__PURE__*/React.createElement(ThemeContext.FannypackThemeContext.Provider, {
    value: themeContextValue
  }, /*#__PURE__*/React.createElement(emotionTheming.ThemeProvider, {
    theme: derivedTheme
  }, /*#__PURE__*/React.createElement(ColorModeContext.Provider, {
    mode: colorMode
  }, /*#__PURE__*/React.createElement(uniqueId.IdProvider, null, /*#__PURE__*/React.createElement(ToastContext.ToastProvider, null, /*#__PURE__*/React.createElement(PageContext.PageProvider, {
    collapseBelow: collapseBelow
  }, /*#__PURE__*/React.createElement(React.Fragment, null, process.env.NODE_ENV !== 'test' && /*#__PURE__*/React.createElement(GlobalStyles.default, null), process.env.NODE_ENV === 'test' ? children : /*#__PURE__*/React.createElement(Box.Box, null, children))))))));
}

exports.Provider = Provider;
