'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
require('../Provider/ThemeContext.js');
require('classnames');
require('emotion');
require('@emotion/core');
require('emotion-theming');
require('@emotion/styled');
require('../utils/useTheme.js');
var __chunk_1 = require('../chunk-4f52fe58.js');
require('lodash/kebabCase');
require('tinycolor2');
require('../utils/isFunction.js');
require('../utils/get.js');
require('../utils/theme.js');
require('../utils/omit.js');
require('../utils/pick.js');
require('../utils/cssProps.js');
require('../utils/useLocalStorage.js');
require('../Provider/ColorModeContext.js');
require('../utils/useColorMode.js');
require('../utils/useStyle.js');
require('../utils/omitBy.js');
require('../utils/useDefaultProps.js');
var useDebounce = require('../utils/useDebounce.js');
require('lodash/uniq');
var useClassName = require('../utils/useClassName.js');
require('../utils/useBreakpoint.js');
require('../utils/uniqueId.js');
require('../utils/times.js');
require('../utils/parseIcons.js');
require('../utils/colors.js');
require('../utils/palette.js');
require('../utils/mergeRefs.js');
require('deepmerge');
require('lodash/set');
require('../utils/applyTheme.js');
require('../utils/bindFns.js');
var createComponent = require('../utils/createComponent.js');
var createElement = require('../utils/createElement.js');
var createHook = require('../utils/createHook.js');
require('../utils/forwardRefWithUse.js');
require('../utils/fieldAdaptors.js');
require('@emotion/is-prop-valid');
require('../utils/htmlProps.js');
require('../utils/OutsideClickHandler.js');
require('../theme/palette.js');
var reakit = require('reakit');
require('../Button/styles-ef2b3fee.js');
require('conditional-wrap');
require('../Box/styles-efc98bd0.js');
var Box = require('../Box/Box.js');
require('../Flex/styles-f03a673b.js');
require('../Flex/Flex.js');
require('../Icon/styles-5971248c.js');
var Icon$1 = require('../Icon/Icon.js');
require('../Text/styles-778c8fc7.js');
var Text = require('../Text/Text.js');
require('../Spinner/styles-154c4cbf.js');
var Spinner = require('../Spinner/Spinner.js');
require('../Button/Button.js');
require('reakit/VisuallyHidden');
require('../Button/ButtonClose.js');
var index$1 = require('../Button/index.js');
require('../Set/styles-86e096b6.js');
var _Set = require('../Set/Set.js');
var Loads = require('react-loads-next');
require('../Input/styles-d5b8ce23.js');
require('react-input-mask');
require('../FieldWrapper/styles-822385f1.js');
require('../Card/styles-60f2ca0e.js');
require('../Card/Card.js');
require('../Card/index.js');
require('../Disclosure/styles-27a9cebb.js');
require('../Disclosure/DisclosureState.js');
require('../Disclosure/Disclosure.js');
require('../Disclosure/DisclosureContent.js');
require('../Disclosure/index.js');
require('../Label/styles-bfcde1a2.js');
require('../Label/Label.js');
require('../FieldWrapper/FieldWrapper.js');
require('../Group/styles-97fa31e0.js');
require('../Group/Group.js');
require('../Input/Input.js');
var index$3 = require('../Input/index.js');
require('../Menu/styles-4fba2491.js');
require('../DropdownMenu/styles-18090575.js');
var DropdownMenuButton = require('../DropdownMenu/DropdownMenuButton.js');
require('../Modal/styles-b6bbf6b0.js');
require('../Popover/styles-fa6dc540.js');
var DropdownMenuPopover = require('../DropdownMenu/DropdownMenuPopover.js');
require('../DropdownMenu/DropdownMenuState.js');
require('../DropdownMenu/DropdownMenu.js');
require('../DropdownMenu/DropdownMenuItem.js');
require('../DropdownMenu/DropdownMenuDisclosure.js');
require('../Divider/styles-b2716364.js');
require('../Divider/Divider.js');
require('../DropdownMenu/DropdownMenuDivider.js');
require('../DropdownMenu/DropdownMenuGroup.js');
var index$4 = require('../DropdownMenu/index.js');
require('../Select/styles-ed13ff30.js');
var styles = require('./styles-e19a7d57.js');
require('../Tag/styles-5e33ddb9.js');
var Tag = require('../Tag/Tag.js');
var SelectMenuItem = require('./SelectMenuItem.js');
var SelectMenuStaticItem = require('./SelectMenuStaticItem.js');

var SelectMenuContext = React.createContext({});

function reducer(state, event) {
  switch (event.type) {
    case 'VALUE_CHANGE':
      {
        return __chunk_1._objectSpread2(__chunk_1._objectSpread2({}, state), {}, {
          page: 1,
          selectedOptions: event.value ? Array.isArray(event.value) ? event.value : [event.value] : []
        });
      }

    case 'INPUT_CHANGE':
      {
        return __chunk_1._objectSpread2(__chunk_1._objectSpread2({}, state), {}, {
          page: 1,
          searchText: event.searchText
        });
      }

    case 'OPTIONS_SET':
      {
        return __chunk_1._objectSpread2(__chunk_1._objectSpread2({}, state), {}, {
          options: event.options
        });
      }

    case 'OPTIONS_FILTERED':
      {
        return __chunk_1._objectSpread2(__chunk_1._objectSpread2({}, state), {}, {
          filteredOptions: event.filteredOptions
        });
      }

    case 'PAGE_INCREMENT':
      {
        return __chunk_1._objectSpread2(__chunk_1._objectSpread2({}, state), {}, {
          page: state.page + 1
        });
      }

    default:
      {
        return state;
      }
  }
}

var useProps = createHook.createHook(function (props, _ref) {
  var themeKey = _ref.themeKey,
      themeKeyOverride = _ref.themeKeyOverride;

  var buttonProps = props.buttonProps,
      cacheKey = props.cacheKey,
      disabled = props.disabled,
      disableClear = props.disableClear,
      dropdownMenuInitialState = props.dropdownMenuInitialState,
      emptyText = props.emptyText,
      errorText = props.errorText,
      loadingText = props.loadingText,
      loadingMoreText = props.loadingMoreText,
      popoverProps = props.popoverProps,
      hasSearch = props.hasSearch,
      hasTags = props.hasTags,
      itemProps = props.itemProps,
      isLoading = props.isLoading,
      isMultiSelect = props.isMultiSelect,
      limit = props.limit,
      loadOptions = props.loadOptions,
      loadVariables = props.loadVariables,
      onChange = props.onChange,
      initialOptions = props.options,
      overrides = props.overrides,
      pagination = props.pagination,
      Empty = props.renderEmpty,
      Error = props.renderError,
      Loading = props.renderLoading,
      LoadingMore = props.renderLoadingMore,
      Option = props.renderOption,
      searchInputProps = props.searchInputProps,
      placeholder = props.placeholder,
      fieldState = props.state,
      tagProps = props.tagProps,
      value = props.value,
      restProps = __chunk_1._objectWithoutPropertiesLoose(props, ["buttonProps", "cacheKey", "disabled", "disableClear", "dropdownMenuInitialState", "emptyText", "errorText", "loadingText", "loadingMoreText", "popoverProps", "hasSearch", "hasTags", "itemProps", "isLoading", "isMultiSelect", "limit", "loadOptions", "loadVariables", "onChange", "options", "overrides", "pagination", "renderEmpty", "renderError", "renderLoading", "renderLoadingMore", "renderOption", "searchInputProps", "placeholder", "state", "tagProps", "value"]); /////////////////////////////////////////////////


  var boxProps = Box.Box.useProps(restProps); //////////////////////////////////////////////////

  var dropdownMenu = index$4.DropdownMenu.useState(__chunk_1._objectSpread2({
    loop: true,
    gutter: 4
  }, dropdownMenuInitialState)); //////////////////////////////////////////////////

  var _React$useState = React.useState(false),
      blockLoad = _React$useState[0],
      setBlockLoad = _React$useState[1];

  var _React$useState2 = React.useState(props.defer || !loadOptions),
      defer = _React$useState2[0],
      setDefer = _React$useState2[1]; //////////////////////////////////////////////////


  var className = useClassName.useClassName({
    style: styles.SelectMenu,
    styleProps: props,
    themeKey: themeKey,
    themeKeyOverride: themeKeyOverride,
    prevClassName: boxProps.className
  });
  var dropdownMenuPopoverClassName = useClassName.useClassName({
    style: styles.SelectMenuPopover,
    styleProps: props,
    themeKey: themeKey,
    themeKeyOverride: themeKeyOverride,
    themeKeySuffix: 'Popover'
  });
  var selectMenuItemsWrapperClassName = useClassName.useClassName({
    style: styles.SelectMenuItemsWrapper,
    styleProps: props,
    themeKey: themeKey,
    themeKeyOverride: themeKeyOverride,
    themeKeySuffix: 'ItemsWrapper'
  }); //////////////////////////////////////////////////

  var _React$useReducer = React.useReducer(reducer, {
    searchText: '',
    filteredOptions: initialOptions,
    options: initialOptions,
    page: 1,
    selectedOptions: []
  }),
      _React$useReducer$ = _React$useReducer[0],
      searchText = _React$useReducer$.searchText,
      filteredOptions = _React$useReducer$.filteredOptions,
      options = _React$useReducer$.options,
      page = _React$useReducer$.page,
      selectedOptions = _React$useReducer$.selectedOptions,
      selectedIndexes = _React$useReducer$.selectedIndexes,
      dispatch = _React$useReducer[1]; //////////////////////////////////////////////////


  var debouncedInputValue = useDebounce.useDebounce(searchText, 500);
  var getOptions = React.useCallback( /*#__PURE__*/function () {
    var _ref3 = __chunk_1._asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref2) {
      var loadVariables, page, _ref2$searchText, searchText, _yield$loadOptions, fetchedOptions, _newOptions;

      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              loadVariables = _ref2.loadVariables, page = _ref2.page, _ref2$searchText = _ref2.searchText, searchText = _ref2$searchText === void 0 ? '' : _ref2$searchText;

              if (!(typeof loadOptions === 'function')) {
                _context.next = 12;
                break;
              }

              if (!blockLoad) {
                _context.next = 4;
                break;
              }

              return _context.abrupt("return", {
                options: options
              });

            case 4:
              _context.next = 6;
              return loadOptions({
                page: page,
                searchText: searchText,
                variables: loadVariables
              });

            case 6:
              _yield$loadOptions = _context.sent;
              fetchedOptions = _yield$loadOptions.options;
              _newOptions = [].concat(options, fetchedOptions);

              if (page === 1) {
                _newOptions = fetchedOptions;
              }

              if (page > 1 && fetchedOptions.length === 0) {
                setBlockLoad(true);
              }

              return _context.abrupt("return", {
                options: _newOptions
              });

            case 12:
              return _context.abrupt("return", undefined);

            case 13:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x) {
      return _ref3.apply(this, arguments);
    };
  }(), [blockLoad, loadOptions, options]);
  var optionsRecord = Loads.useLoads(cacheKey, getOptions, {
    defer: defer,
    variables: [{
      loadVariables: loadVariables,
      page: page,
      searchText: debouncedInputValue
    }]
  }); //////////////////////////////////////////////////

  var visibleOptions = React.useMemo(function () {
    return filteredOptions.slice(0, limit).filter(function (option) {
      if (!option) return false;

      if (hasTags) {
        return !selectedOptions.includes(option);
      }

      return true;
    });
  }, [filteredOptions, hasTags, limit, selectedOptions]); //////////////////////////////////////////////////

  var isLoadingMore = loadOptions && (optionsRecord.isPending || optionsRecord.isIdle) && page > 1;
  var state = 'empty';

  if (visibleOptions.length > 0 || loadOptions && (optionsRecord.isResolved && visibleOptions.length > 0 || isLoadingMore)) {
    state = 'success';
  } else if (isLoading || loadOptions && (optionsRecord.isPending || optionsRecord.isIdle) && page === 1) {
    state = 'loading';
  } else if (loadOptions && optionsRecord.isRejected) {
    state = 'error';
  } //////////////////////////////////////////////////


  var filterOptions = React.useCallback(function (_ref4) {
    var searchText = _ref4.searchText;
    if (loadOptions) return;
    var filteredOptions = options.filter(function (option) {
      return option.label.toLowerCase().includes(searchText.trim().toLowerCase());
    });
    dispatch({
      type: 'OPTIONS_FILTERED',
      filteredOptions: filteredOptions
    });
    return filteredOptions;
  }, [loadOptions, options]); //////////////////////////////////////////////////

  var handleClickItem = React.useCallback(function (_ref5) {
    var option = _ref5.option;
    return function () {
      if (isMultiSelect) {
        var _newOptions2 = [];

        if (selectedOptions.includes(option)) {
          _newOptions2 = selectedOptions.filter(function (selectedOption) {
            return option.key !== selectedOption.key;
          });
        } else {
          _newOptions2 = [].concat(selectedOptions, [option]);
        }

        onChange && onChange(_newOptions2, option);
      } else {
        var _newOptions3 = selectedOptions;

        if (!selectedOptions.includes(option)) {
          _newOptions3 = option;
        } else if (!disableClear) {
          _newOptions3 = '';
        }

        onChange && onChange(_newOptions3, _newOptions3);
        dropdownMenu.hide();
      }
    };
  }, [disableClear, dropdownMenu, isMultiSelect, onChange, selectedOptions]);
  var handleClickButton = React.useCallback(function () {
    if (defer) {
      setDefer(false);
      optionsRecord.load();
    }
  }, [defer, optionsRecord]);
  var handleChangeInput = React.useCallback(function (event) {
    var searchText = event.target.value || '';
    setBlockLoad(false);
    dispatch({
      type: 'INPUT_CHANGE',
      searchText: searchText
    });
    filterOptions({
      searchText: searchText
    });
  }, [filterOptions]);
  var handleClearTag = React.useCallback(function (_ref6) {
    var option = _ref6.option;
    handleClickItem({
      option: option
    })();
  }, [handleClickItem]);
  var handleClearOptions = React.useCallback(function (e) {
    e.stopPropagation();
    dispatch({
      type: 'VALUE_CHANGE',
      value: ''
    });
    onChange && onChange('', '');
  }, [onChange]);
  var handleScrollPopover = React.useCallback(function (event) {
    var target = event.currentTarget;

    if (pagination && !isLoadingMore && !blockLoad && target.scrollHeight > target.offsetHeight && target.scrollHeight - target.offsetHeight - target.scrollTop <= 200) {
      dispatch({
        type: 'PAGE_INCREMENT'
      });
    }

    return;
  }, [blockLoad, isLoadingMore, pagination]); //////////////////////////////////////////////////

  React.useEffect(function () {
    dispatch({
      type: 'VALUE_CHANGE',
      value: value
    });
  }, [value]);
  React.useEffect(function () {
    if (!dropdownMenu.visible) {
      handleChangeInput({
        target: {
          value: ''
        }
      });
    }
  }, [dropdownMenu.visible, handleChangeInput]);
  React.useEffect(function () {
    if (loadOptions && optionsRecord.isResolved) {
      var _optionsRecord$respon, _optionsRecord$respon2;

      var _options = (_optionsRecord$respon = (_optionsRecord$respon2 = optionsRecord.response) === null || _optionsRecord$respon2 === void 0 ? void 0 : _optionsRecord$respon2.options) !== null && _optionsRecord$respon !== void 0 ? _optionsRecord$respon : [];

      dispatch({
        type: 'OPTIONS_SET',
        options: _options
      });
      dispatch({
        type: 'OPTIONS_FILTERED',
        filteredOptions: _options
      });
    }
  }, [loadOptions, optionsRecord.isResolved, optionsRecord.response]); //////////////////////////////////////////////////

  var context = React.useMemo(function () {
    return {
      dropdownMenu: dropdownMenu,
      overrides: overrides,
      themeKey: themeKey,
      themeKeyOverride: themeKeyOverride
    };
  }, [dropdownMenu, overrides, themeKey, themeKeyOverride]); //////////////////////////////////////////////////

  var EmptyStaticItem = React.useCallback(function (props) {
    return /*#__PURE__*/React.createElement(SelectMenuStaticItem.SelectMenuStaticItem, __chunk_1._extends({}, dropdownMenu, props, {
      onClick: function onClick(e) {
        props.onClick && props.onClick(e);
        dropdownMenu.hide();
      }
    }));
  }, [] // eslint-disable-line
  );
  var EmptyItem = React.useCallback(function (props) {
    return /*#__PURE__*/React.createElement(SelectMenuItem.SelectMenuItem, __chunk_1._extends({}, dropdownMenu, props, {
      onClick: function onClick(e) {
        props.onClick && props.onClick(e);
        dropdownMenu.hide();
      }
    }));
  }, [] // eslint-disable-line
  ); //////////////////////////////////////////////////

  return __chunk_1._objectSpread2(__chunk_1._objectSpread2({}, boxProps), {}, {
    className: className,
    children: /*#__PURE__*/React.createElement(SelectMenuContext.Provider, {
      value: context
    }, /*#__PURE__*/React.createElement(SelectMenuButton, __chunk_1._extends({
      disabled: disabled,
      disableClear: disableClear,
      isLoading: isLoading,
      onClick: handleClickButton,
      onClear: handleClearOptions,
      placeholder: placeholder,
      selectedOptions: selectedOptions,
      state: fieldState
    }, buttonProps)), /*#__PURE__*/React.createElement(DropdownMenuPopover.DropdownMenuPopover, __chunk_1._extends({}, dropdownMenu, {
      className: dropdownMenuPopoverClassName,
      overrides: overrides,
      role: "listbox"
    }, popoverProps), /*#__PURE__*/React.createElement(React.Fragment, null, hasSearch && /*#__PURE__*/React.createElement(SelectMenuSearchInput, {
      onChange: handleChangeInput,
      value: searchText,
      searchInputProps: searchInputProps
    }), hasTags && selectedOptions.length > 0 && /*#__PURE__*/React.createElement(SelectMenuTags, {
      onClearTag: handleClearTag,
      selectedOptions: selectedOptions,
      tagProps: tagProps
    }), /*#__PURE__*/React.createElement(Box.Box, {
      use: "ul",
      className: selectMenuItemsWrapperClassName,
      onScroll: handleScrollPopover,
      overrides: overrides
    }, state === 'success' && /*#__PURE__*/React.createElement(React.Fragment, null, visibleOptions.map(function (option, index) {
      return /*#__PURE__*/React.createElement(SelectMenuItem.SelectMenuItem, __chunk_1._extends({
        key: option.key || index
      }, dropdownMenu, {
        "aria-selected": selectedOptions.some(function (selectedOption) {
          return selectedOption.key === option.key;
        }),
        "aria-disabled": option.disabled,
        disabled: option.disabled,
        iconAfter: option.iconAfter,
        iconAfterProps: option.iconAfterProps,
        iconBefore: option.iconBefore,
        iconBeforeProps: option.iconBeforeProps,
        onClick: handleClickItem({
          index: index,
          option: option
        }),
        overrides: overrides
      }, itemProps), /*#__PURE__*/React.createElement(Option, {
        label: option.label,
        searchText: searchText,
        option: option,
        overrides: overrides,
        MatchedLabel: function MatchedLabel(props) {
          return /*#__PURE__*/React.createElement(_MatchedLabel, __chunk_1._extends({
            label: option.label,
            searchText: searchText
          }, props));
        }
      }));
    }), isLoadingMore && /*#__PURE__*/React.createElement(LoadingMore, {
      loadingText: loadingMoreText,
      overrides: overrides
    })), state === 'loading' && /*#__PURE__*/React.createElement(Loading, {
      loadingText: loadingText,
      overrides: overrides
    }), state === 'empty' && /*#__PURE__*/React.createElement(Empty, {
      emptyText: emptyText,
      searchText: searchText,
      overrides: overrides,
      StaticItem: EmptyStaticItem,
      Item: EmptyItem
    }), state === 'error' && /*#__PURE__*/React.createElement(Error, {
      errorText: errorText,
      overrides: overrides
    })))))
  });
}, {
  defaultProps: {
    cacheKey: 'fp-options',
    disabled: false,
    emptyText: 'No results found',
    errorText: 'An error occurred',
    loadingText: 'Loading...',
    loadingMoreText: 'Loading...',
    options: [],
    popoverHeight: '300px',
    renderEmpty: Empty,
    renderError: Error,
    renderLoading: Loading,
    renderLoadingMore: Loading,
    renderOption: _MatchedLabel
  },
  themeKey: 'SelectMenu'
});
var SelectMenu = createComponent.createComponent(function (props) {
  var selectMenuProps = useProps(props);
  return createElement.createElement({
    children: props.children,
    component: reakit.Box,
    use: props.use,
    htmlProps: selectMenuProps
  });
}, {
  attach: {
    useProps: useProps,
    displayName: 'SelectMenu'
  },
  themeKey: 'SelectMenu'
}); //////////////////////////////////////////////////////////////////

function SelectMenuButton(props) {
  var disabled = props.disabled,
      disableClear = props.disableClear,
      isLoading = props.isLoading,
      onClick = props.onClick,
      onClear = props.onClear,
      selectedOptions = props.selectedOptions,
      placeholder = props.placeholder,
      restProps = __chunk_1._objectWithoutPropertiesLoose(props, ["disabled", "disableClear", "isLoading", "onClick", "onClear", "selectedOptions", "placeholder"]);

  var _React$useContext = React.useContext(SelectMenuContext),
      dropdownMenu = _React$useContext.dropdownMenu,
      overrides = _React$useContext.overrides,
      themeKey = _React$useContext.themeKey,
      themeKeyOverride = _React$useContext.themeKeyOverride;

  var buttonClassName = useClassName.useClassName({
    style: styles.SelectMenuButton,
    styleProps: __chunk_1._objectSpread2(__chunk_1._objectSpread2({}, props), {}, {
      overrides: overrides
    }),
    themeKey: themeKey,
    themeKeyOverride: themeKeyOverride,
    themeKeySuffix: 'Button'
  });
  var buttonTextClassName = useClassName.useClassName({
    style: styles.SelectMenuButtonText,
    styleProps: __chunk_1._objectSpread2(__chunk_1._objectSpread2({}, props), {}, {
      overrides: overrides
    }),
    themeKey: themeKey,
    themeKeyOverride: themeKeyOverride,
    themeKeySuffix: 'ButtonText'
  });
  var iconsWrapperClassName = useClassName.useClassName({
    style: styles.SelectMenuButtonIconsWrapper,
    styleProps: __chunk_1._objectSpread2(__chunk_1._objectSpread2({}, props), {}, {
      overrides: overrides
    }),
    themeKey: themeKey,
    themeKeyOverride: themeKeyOverride,
    themeKeySuffix: 'ButtonIconsWrapper'
  });
  var iconClassName = useClassName.useClassName({
    style: styles.SelectMenuButtonIcon,
    styleProps: __chunk_1._objectSpread2(__chunk_1._objectSpread2({}, props), {}, {
      overrides: overrides
    }),
    themeKey: themeKey,
    themeKeyOverride: themeKeyOverride,
    themeKeySuffix: 'ButtonIcon'
  });
  var dropdownMenuButtonProps = DropdownMenuButton.DropdownMenuButton.useProps(__chunk_1._objectSpread2(__chunk_1._objectSpread2({}, dropdownMenu), {}, {
    'aria-haspopup': 'listbox',
    className: buttonClassName,
    disabled: disabled,
    onClick: onClick,
    overrides: overrides
  }, restProps));
  var label = placeholder;

  if (selectedOptions.length === 1) {
    var _selectedOptions$;

    label = selectedOptions === null || selectedOptions === void 0 ? void 0 : (_selectedOptions$ = selectedOptions[0]) === null || _selectedOptions$ === void 0 ? void 0 : _selectedOptions$.label;
  }

  if (selectedOptions.length > 1) {
    var _selectedOptions$2;

    label = (selectedOptions === null || selectedOptions === void 0 ? void 0 : (_selectedOptions$2 = selectedOptions[0]) === null || _selectedOptions$2 === void 0 ? void 0 : _selectedOptions$2.label) + " + " + (selectedOptions.length - 1) + " other" + (selectedOptions.length - 1 > 1 ? 's' : '');
  }

  return /*#__PURE__*/React.createElement(Box.Box, dropdownMenuButtonProps, /*#__PURE__*/React.createElement(Box.Box, {
    className: buttonTextClassName
  }, label), /*#__PURE__*/React.createElement(Box.Box, {
    className: iconsWrapperClassName
  }, /*#__PURE__*/React.createElement(_Set.Set, null, !disableClear && selectedOptions.length > 0 && /*#__PURE__*/React.createElement(ClearButton, {
    onClick: onClear
  }), isLoading ? /*#__PURE__*/React.createElement(Spinner.Spinner, {
    color: "text",
    size: "small"
  }) : /*#__PURE__*/React.createElement(Icon$1.Icon, {
    className: iconClassName,
    icon: "chevron-down"
  }))));
} //////////////////////////////////////////////////////////////////


function SelectMenuSearchInput(props) {
  var onChange = props.onChange,
      searchInputProps = props.searchInputProps,
      value = props.value,
      restProps = __chunk_1._objectWithoutPropertiesLoose(props, ["onChange", "searchInputProps", "value"]);

  var _React$useContext2 = React.useContext(SelectMenuContext),
      overrides = _React$useContext2.overrides,
      themeKey = _React$useContext2.themeKey,
      themeKeyOverride = _React$useContext2.themeKeyOverride;

  var searchInputWrapperClassName = useClassName.useClassName({
    style: styles.SelectMenuSearchInputWrapper,
    styleProps: __chunk_1._objectSpread2(__chunk_1._objectSpread2({}, props), {}, {
      overrides: overrides
    }),
    themeKey: themeKey,
    themeKeyOverride: themeKeyOverride,
    themeKeySuffix: 'SearchInputWrapper'
  });
  var searchInputClassName = useClassName.useClassName({
    style: styles.SelectMenuSearchInput,
    styleProps: __chunk_1._objectSpread2(__chunk_1._objectSpread2({}, props), {}, {
      overrides: overrides
    }),
    themeKey: themeKey,
    themeKeyOverride: themeKeyOverride,
    themeKeySuffix: 'SearchInput'
  });
  return /*#__PURE__*/React.createElement(Box.Box, __chunk_1._extends({
    className: searchInputWrapperClassName
  }, restProps), /*#__PURE__*/React.createElement(index$3.Input, __chunk_1._extends({
    className: searchInputClassName,
    onChange: onChange,
    overrides: overrides,
    placeholder: "Type to search...",
    value: value
  }, searchInputProps)));
} //////////////////////////////////////////////////////////////////


function SelectMenuTags(props) {
  var onClearTag = props.onClearTag,
      selectedOptions = props.selectedOptions,
      tagProps = props.tagProps,
      restProps = __chunk_1._objectWithoutPropertiesLoose(props, ["onClearTag", "selectedOptions", "tagProps"]);

  var _React$useContext3 = React.useContext(SelectMenuContext),
      overrides = _React$useContext3.overrides,
      themeKey = _React$useContext3.themeKey,
      themeKeyOverride = _React$useContext3.themeKeyOverride;

  var tagsWrapperClassName = useClassName.useClassName({
    style: styles.SelectMenuTagsWrapper,
    styleProps: __chunk_1._objectSpread2(__chunk_1._objectSpread2({}, props), {}, {
      overrides: overrides
    }),
    themeKey: themeKey,
    themeKeyOverride: themeKeyOverride,
    themeKeySuffix: 'TagsWrapper'
  });
  return /*#__PURE__*/React.createElement(Box.Box, __chunk_1._extends({
    className: tagsWrapperClassName
  }, restProps), /*#__PURE__*/React.createElement(_Set.Set, {
    spacing: "minor-1",
    overrides: overrides
  }, selectedOptions.map(function (option) {
    return /*#__PURE__*/React.createElement(Tag.Tag, __chunk_1._extends({
      key: option.key,
      palette: "primaryTint",
      onRemove: function onRemove() {
        return onClearTag({
          option: option
        });
      },
      overrides: overrides
    }, tagProps), option.label);
  })));
} //////////////////////////////////////////////////////////////////


function _MatchedLabel(props) {
  var label = props.label,
      searchText = props.searchText,
      restProps = __chunk_1._objectWithoutPropertiesLoose(props, ["label", "searchText"]);

  var _React$useContext4 = React.useContext(SelectMenuContext),
      overrides = _React$useContext4.overrides,
      themeKey = _React$useContext4.themeKey,
      themeKeyOverride = _React$useContext4.themeKeyOverride;

  var className = useClassName.useClassName({
    style: styles.SelectMenuItemText,
    styleProps: props,
    themeKey: themeKey,
    themeKeyOverride: themeKeyOverride,
    themeKeySuffix: 'ItemText'
  });

  var escapeStringRegexp = function escapeStringRegexp(string) {
    return string.replace(/[|\\{}()[\]^$+*?.]/g, '\\$&');
  };

  var match = label.match(new RegExp(escapeStringRegexp(searchText), 'i')) || [];
  var preText = label.slice(0, match.index);
  var highlightedText = match[0];
  var postText = label.slice(match.index + (match[0] || '').length);
  return highlightedText ? /*#__PURE__*/React.createElement(Text.Text, __chunk_1._extends({
    className: className,
    overrides: overrides
  }, restProps), preText && /*#__PURE__*/React.createElement(Text.Text, {
    overrides: overrides
  }, preText), highlightedText && /*#__PURE__*/React.createElement(Text.Text, {
    fontWeight: "semibold",
    overrides: overrides
  }, highlightedText), postText && /*#__PURE__*/React.createElement(Text.Text, {
    overrides: overrides
  }, postText)) : /*#__PURE__*/React.createElement(Text.Text, __chunk_1._extends({
    className: className,
    overrides: overrides
  }, restProps), label);
} //////////////////////////////////////////////////////////////////


function Empty(props) {
  var emptyText = props.emptyText,
      overrides = props.overrides,
      restProps = __chunk_1._objectWithoutPropertiesLoose(props, ["emptyText", "overrides"]);

  return /*#__PURE__*/React.createElement(SelectMenuStaticItem.SelectMenuStaticItem, __chunk_1._extends({
    overrides: overrides
  }, restProps), emptyText);
} //////////////////////////////////////////////////////////////////


function Loading(props) {
  var loadingText = props.loadingText,
      overrides = props.overrides,
      restProps = __chunk_1._objectWithoutPropertiesLoose(props, ["loadingText", "overrides"]);

  return /*#__PURE__*/React.createElement(SelectMenuStaticItem.SelectMenuStaticItem, __chunk_1._extends({
    display: "flex",
    alignItems: "center",
    overrides: overrides
  }, restProps), /*#__PURE__*/React.createElement(Spinner.Spinner, {
    size: "small",
    overrides: overrides
  }), /*#__PURE__*/React.createElement(Text.Text, {
    marginLeft: "major-1",
    overrides: overrides
  }, loadingText));
} //////////////////////////////////////////////////////////////////


function ClearButton(props) {
  var buttonProps = props.buttonProps,
      onClick = props.onClick,
      restProps = __chunk_1._objectWithoutPropertiesLoose(props, ["buttonProps", "onClick"]);

  var _React$useContext5 = React.useContext(SelectMenuContext),
      overrides = _React$useContext5.overrides,
      themeKey = _React$useContext5.themeKey,
      themeKeyOverride = _React$useContext5.themeKeyOverride;

  var wrapperClassName = useClassName.useClassName({
    style: styles.SelectMenuClearButtonWrapper,
    styleProps: __chunk_1._objectSpread2(__chunk_1._objectSpread2({}, props), {}, {
      overrides: overrides
    }),
    themeKey: themeKey,
    themeKeyOverride: themeKeyOverride,
    themeKeySuffix: 'ClearButtonWrapper'
  });
  var buttonClassName = useClassName.useClassName({
    style: styles.SelectMenuClearButton,
    styleProps: __chunk_1._objectSpread2(__chunk_1._objectSpread2({}, props), {}, {
      overrides: overrides
    }),
    themeKey: themeKey,
    themeKeyOverride: themeKeyOverride,
    themeKeySuffix: 'ClearButton'
  });
  return /*#__PURE__*/React.createElement(Box.Box, __chunk_1._extends({
    className: wrapperClassName,
    overrides: overrides
  }, restProps), /*#__PURE__*/React.createElement(index$1.Button.Close, __chunk_1._extends({
    className: buttonClassName,
    onClick: onClick,
    iconProps: {
      fontSize: '200'
    },
    size: "small",
    onMouseDown: function onMouseDown(e) {
      return e.preventDefault();
    },
    overrides: overrides
  }, buttonProps)));
} //////////////////////////////////////////////////////////////////


function Error(props) {
  var errorText = props.errorText,
      overrides = props.overrides,
      restProps = __chunk_1._objectWithoutPropertiesLoose(props, ["errorText", "overrides"]);

  return /*#__PURE__*/React.createElement(SelectMenuStaticItem.SelectMenuStaticItem, __chunk_1._extends({
    overrides: overrides
  }, restProps), errorText);
}

exports.SelectMenu = SelectMenu;
exports.SelectMenuContext = SelectMenuContext;
