'use strict';

require('react');
require('../Provider/ThemeContext.js');
require('classnames');
var emotion = require('emotion');
var core = require('@emotion/core');
require('emotion-theming');
require('@emotion/styled');
require('../utils/useTheme.js');
var __chunk_1 = require('../chunk-4f52fe58.js');
require('lodash/kebabCase');
require('tinycolor2');
require('../utils/isFunction.js');
require('../utils/get.js');
var theme = require('../utils/theme.js');
require('../utils/omit.js');
require('../utils/pick.js');
require('../utils/cssProps.js');
require('../utils/useLocalStorage.js');
require('../Provider/ColorModeContext.js');
require('../utils/useColorMode.js');
require('../utils/useStyle.js');
require('../utils/omitBy.js');
require('../utils/useDefaultProps.js');
require('../utils/useDebounce.js');
require('lodash/uniq');
require('../utils/useClassName.js');
require('../utils/useBreakpoint.js');
require('../utils/uniqueId.js');
require('../utils/times.js');
require('../utils/parseIcons.js');
var colors = require('../utils/colors.js');
require('../utils/palette.js');
require('../utils/mergeRefs.js');
require('deepmerge');
require('lodash/set');
require('../utils/applyTheme.js');
require('../utils/bindFns.js');
require('../utils/createComponent.js');
require('../utils/createElement.js');
require('../utils/createHook.js');
require('../utils/forwardRefWithUse.js');
require('../utils/fieldAdaptors.js');
require('@emotion/is-prop-valid');
require('../utils/htmlProps.js');
require('../utils/OutsideClickHandler.js');
var getHiddenInputStyles = require('../utils/getHiddenInputStyles.js');

function _templateObject12() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  & {\n    ", ";\n  }\n"]);

  _templateObject12 = function _templateObject12() {
    return data;
  };

  return data;
}

function _templateObject11() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  & {\n    ", ";\n  }\n"]);

  _templateObject11 = function _templateObject11() {
    return data;
  };

  return data;
}

function _templateObject10() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  & {\n    ", ";\n  }\n"]);

  _templateObject10 = function _templateObject10() {
    return data;
  };

  return data;
}

function _templateObject9() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      background: ", ";\n      content: '';\n      border-radius: 100%;\n      border: 1px solid #bdbdbd;\n      height: 1em;\n      width: 1em;\n      top: 0.2em;\n      left: 0.2em;\n      transition: all ease 0.2s;\n      position: absolute;\n    "]);

  _templateObject9 = function _templateObject9() {
    return data;
  };

  return data;
}

function _templateObject8() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      border-color: ", ";\n    "]);

  _templateObject8 = function _templateObject8() {
    return data;
  };

  return data;
}

function _templateObject7() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      border-color: ", ";\n      left: 1.25em;\n    "]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      background: ", ";\n    "]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      background-color: ", ";\n      border-color: ", ";\n    "]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      background-color: ", ";\n      transition: all ease 0.2s;\n    "]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  && {\n    font-weight: ", ";\n  }\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  background-color: ", ";\n  border: 1px solid #bdbdbd;\n  border-radius: 1em;\n  height: 1.5em;\n  position: relative;\n  width: 2.5em;\n  transition: box-shadow 0.1s ease-in-out 0s, border-color 0.1s, background-color 0.1s;\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  && {\n    display: flex;\n    align-items: center;\n  }\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var Switch = function Switch(styleProps) {
  return emotion.css(_templateObject(), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var SwitchIcon = function SwitchIcon(styleProps) {
  return emotion.css(_templateObject2(), theme.palette('background')(styleProps), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var SwitchLabel = function SwitchLabel(styleProps) {
  return emotion.css(_templateObject3(), theme.fontWeight('normal')(styleProps), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var HiddenSwitch = function HiddenSwitch(styleProps) {
  return getHiddenInputStyles.getHiddenInputStyles({
    iconClassName: 'fp-SwitchIcon',
    checkedCss: core.css(_templateObject4(), theme.palette(styleProps.palette || 'primary')(styleProps)),
    disabledCheckedCss: core.css(_templateObject5(), colors.tint(0.5, styleProps.palette || 'primary')(styleProps), colors.tint(0.5, styleProps.palette || 'primary')(styleProps)),
    disabledUncheckedIconCss: core.css(_templateObject6(), theme.palette('white700')(styleProps)),
    checkedIconCss: core.css(_templateObject7(), theme.palette(styleProps.palette || 'primary')(styleProps)),
    disabledCheckedIconCss: core.css(_templateObject8(), colors.tint(0.5, styleProps.palette || 'primary')(styleProps)),
    uncheckedIconCss: core.css(_templateObject9(), theme.palette('background')(styleProps)),
    styleProps: styleProps,
    themeKey: 'Switch.Icon'
  });
};
var SwitchGroup = function SwitchGroup(styleProps) {
  return emotion.css(_templateObject10(), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var SwitchField = function SwitchField(styleProps) {
  return emotion.css(_templateObject11(), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var SwitchGroupField = function SwitchGroupField(styleProps) {
  return emotion.css(_templateObject12(), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};

var styles = /*#__PURE__*/Object.freeze({
  Switch: Switch,
  SwitchIcon: SwitchIcon,
  SwitchLabel: SwitchLabel,
  HiddenSwitch: HiddenSwitch,
  SwitchGroup: SwitchGroup,
  SwitchField: SwitchField,
  SwitchGroupField: SwitchGroupField
});

exports.HiddenSwitch = HiddenSwitch;
exports.Switch = Switch;
exports.SwitchField = SwitchField;
exports.SwitchGroup = SwitchGroup;
exports.SwitchGroupField = SwitchGroupField;
exports.SwitchIcon = SwitchIcon;
exports.SwitchLabel = SwitchLabel;
exports.styles = styles;
