'use strict';

require('react');
require('../Provider/ThemeContext.js');
require('classnames');
var emotion = require('emotion');
var core = require('@emotion/core');
require('emotion-theming');
require('@emotion/styled');
require('../utils/useTheme.js');
var __chunk_1 = require('../chunk-4f52fe58.js');
require('lodash/kebabCase');
require('tinycolor2');
require('../utils/isFunction.js');
require('../utils/get.js');
var theme = require('../utils/theme.js');
require('../utils/omit.js');
require('../utils/pick.js');
require('../utils/cssProps.js');
require('../utils/useLocalStorage.js');
require('../Provider/ColorModeContext.js');
require('../utils/useColorMode.js');
require('../utils/useStyle.js');
require('../utils/omitBy.js');
require('../utils/useDefaultProps.js');
require('../utils/useDebounce.js');
require('lodash/uniq');
require('../utils/useClassName.js');
require('../utils/useBreakpoint.js');
require('../utils/uniqueId.js');
require('../utils/times.js');
require('../utils/parseIcons.js');
require('../utils/colors.js');
require('../utils/palette.js');
require('../utils/mergeRefs.js');
require('deepmerge');
require('lodash/set');
require('../utils/applyTheme.js');
require('../utils/bindFns.js');
require('../utils/createComponent.js');
require('../utils/createElement.js');
require('../utils/createHook.js');
require('../utils/forwardRefWithUse.js');
require('../utils/fieldAdaptors.js');
require('@emotion/is-prop-valid');
require('../utils/htmlProps.js');
require('../utils/OutsideClickHandler.js');

function _templateObject18() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  color: ", ";\n  font-weight: ", ";\n  font-size: ", "rem;\n  text-transform: uppercase;\n"]);

  _templateObject18 = function _templateObject18() {
    return data;
  };

  return data;
}

function _templateObject17() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      ", ";\n    "]);

  _templateObject17 = function _templateObject17() {
    return data;
  };

  return data;
}

function _templateObject16() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      border: 1px solid ", ";\n    "]);

  _templateObject16 = function _templateObject16() {
    return data;
  };

  return data;
}

function _templateObject15() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  border-radius: ", ";\n  overflow: hidden;\n\n  ", "\n\n  ", "\n\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject15 = function _templateObject15() {
    return data;
  };

  return data;
}

function _templateObject14() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  & {\n    ", ";\n  }\n"]);

  _templateObject14 = function _templateObject14() {
    return data;
  };

  return data;
}

function _templateObject13() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      background-color: ", ";\n    "]);

  _templateObject13 = function _templateObject13() {
    return data;
  };

  return data;
}

function _templateObject12() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  border-top: 1px solid ", ";\n\n  ", "\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject12 = function _templateObject12() {
    return data;
  };

  return data;
}

function _templateObject11() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  padding: ", "rem ", "rem;\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject11 = function _templateObject11() {
    return data;
  };

  return data;
}

function _templateObject10() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  padding: ", "rem ", "rem;\n  vertical-align: middle;\n  ", ";\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject10 = function _templateObject10() {
    return data;
  };

  return data;
}

function _templateObject9() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  & {\n    ", ";\n  }\n"]);

  _templateObject9 = function _templateObject9() {
    return data;
  };

  return data;
}

function _templateObject8() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      background-color: ", ";\n    "]);

  _templateObject8 = function _templateObject8() {
    return data;
  };

  return data;
}

function _templateObject7() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  border-bottom: 1px solid ", ";\n\n  ", "\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n          & thead {\n            display: none;\n          }\n\n          & tbody tr:not(:last-child) {\n            border-bottom: 1px solid ", ";\n          }\n\n          & tbody td {\n            display: block;\n            text-align: left !important;\n            padding: ", "rem ", "rem;\n\n            &::before {\n              display: block;\n              content: attr(data-content);\n              ", ";\n\n              & {\n                ", ";\n              }\n            }\n          }\n\n          & tfoot td {\n            display: block;\n            text-align: left !important;\n          }\n\n          & {\n            ", ";\n          }\n        "]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      ", ";\n    "]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      & tbody tr:nth-child(even) {\n        background-color: ", ";\n      }\n    "]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      & tbody tr:hover {\n        background-color: ", ";\n      }\n    "]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      & tbody tr:not(:last-child) {\n        border-bottom: 1px solid ", ";\n      }\n    "]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  border-collapse: collapse;\n  border-spacing: 0;\n  text-align: left;\n  width: 100%;\n  color: ", ";\n\n  ", "\n\n  ", "\n\n  ", "\n\n  ", "\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var Table = function Table(styleProps) {
  return emotion.css(_templateObject(), theme.palette('text200')(styleProps), styleProps.hasDividers && core.css(_templateObject2(), theme.palette(styleProps.dividerColor, styleProps.dividerColor)(styleProps)), styleProps.isHoverable && core.css(_templateObject3(), theme.palette(styleProps.hoverColor, styleProps.hoverColor)(styleProps)), styleProps.isStriped && core.css(_templateObject4(), theme.palette(styleProps.stripeColor, styleProps.stripeColor)(styleProps)), styleProps.isResponsive && core.css(_templateObject5(), theme.breakpoint("max-" + styleProps.responsiveBreakpoint, core.css(_templateObject6(), theme.palette(styleProps.dividerColor, styleProps.dividerColor)(styleProps), theme.space(2)(styleProps), theme.space(4)(styleProps), tableHeadCellText(styleProps), theme.theme(styleProps.themeKey, "css.responsive.headCellText")(styleProps), theme.theme(styleProps.themeKey, "css.responsive.root")(styleProps)))(styleProps)), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var TableHead = function TableHead(styleProps) {
  return emotion.css(_templateObject7(), theme.palette('white800')(styleProps), styleProps.tableVariant !== 'minimal' && core.css(_templateObject8(), theme.palette('white600')(styleProps)), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var TableRow = function TableRow(styleProps) {
  return emotion.css(_templateObject9(), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var TableHeadCell = function TableHeadCell(styleProps) {
  return emotion.css(_templateObject10(), theme.space(3)(styleProps), theme.space(4)(styleProps), tableHeadCellText(styleProps), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var TableCell = function TableCell(styleProps) {
  return emotion.css(_templateObject11(), theme.space(3)(styleProps), theme.space(4)(styleProps), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var TableFoot = function TableFoot(styleProps) {
  return emotion.css(_templateObject12(), theme.palette('white800')(styleProps), styleProps.tableVariant !== 'minimal' && core.css(_templateObject13(), theme.palette('white600')(styleProps)), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var TableBody = function TableBody(styleProps) {
  return emotion.css(_templateObject14(), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var TableWrapper = function TableWrapper(styleProps) {
  return emotion.css(_templateObject15(), theme.borderRadius('default')(styleProps), styleProps.variant === 'default' && core.css(_templateObject16(), theme.palette('white800')(styleProps)), styleProps.variant === 'shadowed' && core.css(_templateObject17(), theme.altitude('100')(styleProps)), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var tableHeadCellText = function tableHeadCellText(styleProps) {
  return core.css(_templateObject18(), theme.palette('text100')(styleProps), theme.fontWeight('semibold')(styleProps), theme.fontSize('100')(styleProps));
};

var styles = /*#__PURE__*/Object.freeze({
  Table: Table,
  TableHead: TableHead,
  TableRow: TableRow,
  TableHeadCell: TableHeadCell,
  TableCell: TableCell,
  TableFoot: TableFoot,
  TableBody: TableBody,
  TableWrapper: TableWrapper,
  tableHeadCellText: tableHeadCellText
});

exports.Table = Table;
exports.TableBody = TableBody;
exports.TableCell = TableCell;
exports.TableFoot = TableFoot;
exports.TableHead = TableHead;
exports.TableHeadCell = TableHeadCell;
exports.TableRow = TableRow;
exports.TableWrapper = TableWrapper;
exports.styles = styles;
exports.tableHeadCellText = tableHeadCellText;
