'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
require('../Provider/ThemeContext.js');
require('classnames');
require('emotion');
require('@emotion/core');
require('emotion-theming');
require('@emotion/styled');
require('../utils/useTheme.js');
var __chunk_1 = require('../chunk-4f52fe58.js');
require('lodash/kebabCase');
require('tinycolor2');
require('../utils/isFunction.js');
require('../utils/get.js');
require('../utils/theme.js');
require('../utils/omit.js');
require('../utils/pick.js');
require('../utils/cssProps.js');
require('../utils/useLocalStorage.js');
require('../Provider/ColorModeContext.js');
require('../utils/useColorMode.js');
require('../utils/useStyle.js');
require('../utils/omitBy.js');
require('../utils/useDefaultProps.js');
require('../utils/useDebounce.js');
require('lodash/uniq');
var useClassName = require('../utils/useClassName.js');
require('../utils/useBreakpoint.js');
require('../utils/uniqueId.js');
require('../utils/times.js');
require('../utils/parseIcons.js');
require('../utils/colors.js');
require('../utils/palette.js');
require('../utils/mergeRefs.js');
require('deepmerge');
require('lodash/set');
require('../utils/applyTheme.js');
require('../utils/bindFns.js');
var createComponent = require('../utils/createComponent.js');
var createElement = require('../utils/createElement.js');
var createHook = require('../utils/createHook.js');
require('../utils/forwardRefWithUse.js');
require('../utils/fieldAdaptors.js');
require('@emotion/is-prop-valid');
require('../utils/htmlProps.js');
require('../utils/OutsideClickHandler.js');
var reakit = require('reakit');
require('../Box/styles-efc98bd0.js');
var Box = require('../Box/Box.js');
var styles = require('./styles-2a5f767d.js');
require('./TabsState.js');
var Tabs = require('./Tabs.js');

var TabsListContext = React.createContext({});
var useProps = createHook.createHook(function (props, _ref) {
  var themeKey = _ref.themeKey,
      themeKeyOverride = _ref.themeKeyOverride;

  var align = props.align,
      baseId = props.baseId,
      children = props.children,
      id = props.id,
      variant = props.variant,
      overrides = props.overrides,
      palette = props.palette,
      disabled = props.disabled,
      focusable = props.focusable,
      first = props.first,
      last = props.last,
      move = props.move,
      currentId = props.currentId,
      wrap = props.wrap,
      groups = props.groups,
      items = props.items,
      setCurrentId = props.setCurrentId,
      orientation = props.orientation,
      unstable_virtual = props.unstable_virtual,
      unstable_moves = props.unstable_moves,
      htmlProps = __chunk_1._objectWithoutPropertiesLoose(props, ["align", "baseId", "children", "id", "variant", "overrides", "palette", "disabled", "focusable", "first", "last", "move", "currentId", "wrap", "groups", "items", "setCurrentId", "orientation", "unstable_virtual", "unstable_moves"]);

  var _React$useContext = React.useContext(Tabs.TabsContext),
      tabOverrides = _React$useContext.overrides,
      tabs = _React$useContext.tabs;

  var tabsListProps = reakit.useTabList(__chunk_1._objectSpread2({
    baseId: baseId,
    disabled: disabled,
    focusable: focusable,
    first: first,
    last: last,
    move: move,
    currentId: currentId,
    orientation: orientation,
    wrap: wrap,
    groups: groups,
    items: items,
    setCurrentId: setCurrentId,
    unstable_virtual: unstable_virtual,
    unstable_moves: unstable_moves
  }, tabs), htmlProps);
  var boxProps = Box.Box.useProps(__chunk_1._objectSpread2(__chunk_1._objectSpread2({}, htmlProps), tabsListProps));
  var className = useClassName.useClassName({
    style: styles.TabsList,
    styleProps: __chunk_1._objectSpread2(__chunk_1._objectSpread2(__chunk_1._objectSpread2({}, tabs), props), {}, {
      overrides: __chunk_1._objectSpread2(__chunk_1._objectSpread2({}, tabOverrides), overrides)
    }),
    themeKey: themeKey,
    themeKeyOverride: themeKeyOverride,
    prevClassName: boxProps.className
  });
  var contextValue = React.useMemo(function () {
    return {
      align: align,
      variant: variant,
      overrides: overrides,
      palette: palette
    };
  }, [align, variant, overrides, palette]);
  return __chunk_1._objectSpread2(__chunk_1._objectSpread2({}, boxProps), {}, {
    className: className,
    children: /*#__PURE__*/React.createElement(TabsListContext.Provider, {
      value: contextValue
    }, children)
  });
}, {
  defaultProps: {
    align: 'left',
    variant: 'default',
    palette: 'primary'
  },
  themeKey: 'Tabs.List'
});
var TabsList = createComponent.createComponent(function (props) {
  var tabsListProps = useProps(props);
  return createElement.createElement({
    children: props.children,
    component: reakit.Box,
    use: props.use,
    htmlProps: tabsListProps
  });
}, {
  attach: {
    useProps: useProps,
    displayName: 'Tabs.List'
  },
  themeKey: 'Tabs.List'
});

exports.TabsList = TabsList;
exports.TabsListContext = TabsListContext;
