'use strict';

require('react');
require('../Provider/ThemeContext.js');
require('classnames');
var emotion = require('emotion');
var core = require('@emotion/core');
require('emotion-theming');
require('@emotion/styled');
require('../utils/useTheme.js');
var __chunk_1 = require('../chunk-4f52fe58.js');
require('lodash/kebabCase');
require('tinycolor2');
require('../utils/isFunction.js');
require('../utils/get.js');
var theme = require('../utils/theme.js');
require('../utils/omit.js');
require('../utils/pick.js');
require('../utils/cssProps.js');
require('../utils/useLocalStorage.js');
require('../Provider/ColorModeContext.js');
require('../utils/useColorMode.js');
require('../utils/useStyle.js');
require('../utils/omitBy.js');
require('../utils/useDefaultProps.js');
require('../utils/useDebounce.js');
require('lodash/uniq');
require('../utils/useClassName.js');
require('../utils/useBreakpoint.js');
require('../utils/uniqueId.js');
require('../utils/times.js');
require('../utils/parseIcons.js');
require('../utils/colors.js');
require('../utils/palette.js');
require('../utils/mergeRefs.js');
require('deepmerge');
require('lodash/set');
require('../utils/applyTheme.js');
require('../utils/bindFns.js');
require('../utils/createComponent.js');
require('../utils/createElement.js');
require('../utils/createHook.js');
require('../utils/forwardRefWithUse.js');
require('../utils/fieldAdaptors.js');
require('@emotion/is-prop-valid');
require('../utils/htmlProps.js');
require('../utils/OutsideClickHandler.js');

function _templateObject11() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n        box-shadow: inset 0 -2px 0 0 ", ";\n      "]);

  _templateObject11 = function _templateObject11() {
    return data;
  };

  return data;
}

function _templateObject10() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n        background-color: ", ";\n      "]);

  _templateObject10 = function _templateObject10() {
    return data;
  };

  return data;
}

function _templateObject9() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n        color: ", ";\n      "]);

  _templateObject9 = function _templateObject9() {
    return data;
  };

  return data;
}

function _templateObject8() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n        box-shadow: inset 0 -2px 0 0 ", ";\n      "]);

  _templateObject8 = function _templateObject8() {
    return data;
  };

  return data;
}

function _templateObject7() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      color: ", ";\n      fill: ", ";\n\n      ", " & {\n        ", ";\n      }\n    "]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      border-radius: ", ";\n      height: 44px;\n    "]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      min-height: 2.75rem;\n    "]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n      &&&&&& {\n        cursor: pointer;\n        margin: 0 0.8rem;\n      }\n    "]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  align-items: center;\n  color: inherit;\n  height: 100%;\n  font-weight: ", ";\n  text-decoration: none;\n\n  &&&& {\n    display: flex;\n  }\n\n  ", "\n\n  ", "\n\n  ", "\n\n  ", "\n\n  &:hover {\n    ", "\n\n    ", "\n\n    & {\n      ", ";\n    }\n  }\n\n  &:focus {\n    outline: none;\n    color: ", ";\n    fill: ", ";\n\n    ", "\n\n    & {\n      ", ";\n    }\n  }\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  display: flex;\n\n  &:not(:last-child) {\n    margin-right: ", "rem;\n  }\n\n  &&&&& li {\n    align-items: center;\n    display: flex;\n  }\n\n  &&&&& > *:not(:last-child) {\n    margin-right: ", "rem;\n  }\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  display: flex;\n  justify-content: space-between;\n  min-height: 60px;\n\n  & {\n    ", ";\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var TopNav = function TopNav(styleProps) {
  return emotion.css(_templateObject(), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var TopNavSection = function TopNavSection(styleProps) {
  return emotion.css(_templateObject2(), theme.space(2, 'major')(styleProps), theme.space(1, 'minor')(styleProps), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};
var TopNavItem = function TopNavItem(styleProps) {
  return emotion.css(_templateObject3(), theme.fontWeight('semibold')(styleProps), (styleProps.href || styleProps.onClick || styleProps.navId) && core.css(_templateObject4()), styleProps.variant === 'default' && core.css(_templateObject5()), styleProps.variant === 'pill' && core.css(_templateObject6(), theme.borderRadius('default')(styleProps)), styleProps.isActive && core.css(_templateObject7(), theme.palette(styleProps.palette, styleProps.palette)(styleProps), theme.palette(styleProps.palette, styleProps.palette)(styleProps), styleProps.variant === 'default' && core.css(_templateObject8(), theme.palette(styleProps.palette, styleProps.palette)(styleProps)), theme.theme(styleProps.themeKey, "css.active")(styleProps)), styleProps.variant !== 'pill' && core.css(_templateObject9(), theme.palette(styleProps.palette, styleProps.palette)(styleProps)), styleProps.variant === 'pill' && core.css(_templateObject10(), theme.palette('white700')(styleProps)), theme.theme(styleProps.themeKey, "css.hover")(styleProps), theme.palette(styleProps.palette, styleProps.palette)(styleProps), theme.palette(styleProps.palette, styleProps.palette)(styleProps), styleProps.variant === 'default' && core.css(_templateObject11(), theme.palette(styleProps.palette, styleProps.palette)(styleProps)), theme.theme(styleProps.themeKey, "css.focus")(styleProps), theme.theme(styleProps.themeKey, "css.root")(styleProps));
};

var styles = /*#__PURE__*/Object.freeze({
  TopNav: TopNav,
  TopNavSection: TopNavSection,
  TopNavItem: TopNavItem
});

exports.TopNav = TopNav;
exports.TopNavItem = TopNavItem;
exports.TopNavSection = TopNavSection;
exports.styles = styles;
