'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../Provider/ThemeContext.js');
require('classnames');
require('emotion');
require('@emotion/core');
require('emotion-theming');
require('@emotion/styled');
require('./useTheme.js');
var __chunk_1 = require('../chunk-4f52fe58.js');
require('./get.js');
var omit = require('./omit.js');
require('./useLocalStorage.js');
require('../Provider/ColorModeContext.js');
require('./useColorMode.js');
require('./omitBy.js');
var useDefaultProps = require('./useDefaultProps.js');

function createHook(useHook, config) {
  return function (props, _temp) {
    var _ref = _temp === void 0 ? {} : _temp,
        _ref$themeKey = _ref.themeKey,
        themeKeyOverride = _ref$themeKey === void 0 ? undefined : _ref$themeKey;

    // @ts-ignore
    var themeKey = themeKeyOverride || (props === null || props === void 0 ? void 0 : props.themeKey) || (config === null || config === void 0 ? void 0 : config.themeKey);

    var _useDefaultProps = useDefaultProps.useDefaultProps(props, __chunk_1._objectSpread2(__chunk_1._objectSpread2({}, config), {}, {
      themeKey: themeKey
    })),
        newProps = _useDefaultProps.props,
        newThemeKey = _useDefaultProps.themeKey; // @ts-ignore


    return useHook(omit.omit(newProps, 'themeKey'), {
      themeKey: config === null || config === void 0 ? void 0 : config.themeKey,
      themeKeyOverride: newThemeKey
    });
  };
}

exports.createHook = createHook;
