'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('react');
require('../Provider/ThemeContext.js');
require('classnames');
var emotion = require('emotion');
var core = require('@emotion/core');
require('emotion-theming');
require('@emotion/styled');
require('./useTheme.js');
var __chunk_1 = require('../chunk-4f52fe58.js');
require('lodash/kebabCase');
require('tinycolor2');
require('./isFunction.js');
require('./get.js');
var theme = require('./theme.js');
require('./omit.js');
require('./pick.js');
require('./cssProps.js');
require('./useLocalStorage.js');
require('../Provider/ColorModeContext.js');
require('./useColorMode.js');
require('./useStyle.js');
require('./omitBy.js');
require('./useDefaultProps.js');
require('./useDebounce.js');
require('lodash/uniq');
require('./useClassName.js');
require('./useBreakpoint.js');
require('./uniqueId.js');
require('./times.js');
require('./parseIcons.js');
require('./colors.js');
require('./palette.js');
require('./mergeRefs.js');
require('deepmerge');
require('lodash/set');
require('./applyTheme.js');
require('./bindFns.js');
require('./createComponent.js');
require('./createElement.js');
require('./createHook.js');
require('./forwardRefWithUse.js');
require('./fieldAdaptors.js');
require('@emotion/is-prop-valid');
require('./htmlProps.js');
require('./OutsideClickHandler.js');

function _templateObject3() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n          box-shadow: ", " 0px 0px 0px 3px !important;\n        "]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n          border-color: ", ";\n        "]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n    height: 1em;\n    width: 1em;\n    overflow: hidden;\n    position: absolute;\n    opacity: 0;\n\n    &:focus {\n      outline: none;\n    }\n\n    & + .", " {\n      ", "\n\n      &::before {\n        ", ";\n\n        & {\n          ", ";\n        }\n      }\n    }\n    &:not(:checked) + .", " {\n      ", "\n    }\n    &[disabled] + .", " {\n      background-color: ", ";\n      box-shadow: unset;\n\n      &::before {\n        ", ";\n        & {\n          ", ";\n        }\n      }\n\n      & {\n        ", ";\n      }\n    }\n    &:focus + .", " {\n      border-color: ", ";\n      box-shadow: ", " 0px 0px 0px 3px !important;\n\n      & {\n        ", ";\n      }\n    }\n    &:not([disabled]):checked + .", " {\n      border-color: ", ";\n      ", ";\n    }\n    &:checked + .", " {\n      ", ";\n\n      &::before {\n        ", ";\n      }\n\n      & {\n        ", ";\n      }\n    }\n    &[disabled]:checked + .", "::before {\n      ", ";\n\n      & {\n        ", ";\n      }\n    }\n\n    & {\n      ", ";\n    }\n  "]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
function getHiddenInputStyles(_ref) {
  var iconClassName = _ref.iconClassName,
      checkedCss = _ref.checkedCss,
      disabledCheckedCss = _ref.disabledCheckedCss,
      disabledCheckedIconCss = _ref.disabledCheckedIconCss,
      disabledUncheckedIconCss = _ref.disabledUncheckedIconCss,
      checkedIconCss = _ref.checkedIconCss,
      uncheckedIconCss = _ref.uncheckedIconCss,
      styleProps = _ref.styleProps,
      themeKey = _ref.themeKey;
  // @ts-ignore
  return emotion.css(_templateObject(), iconClassName, styleProps.state && core.css(_templateObject2(), theme.palette("" + styleProps.state)(styleProps)), uncheckedIconCss, theme.theme(themeKey, "unchecked")(styleProps), iconClassName, styleProps.state && core.css(_templateObject3(), theme.palette(styleProps.state + "Tint")(styleProps)), iconClassName, theme.palette('white700')(styleProps), disabledUncheckedIconCss, theme.theme(themeKey, "uncheckedDisabled")(styleProps), theme.theme(themeKey, "disabled")(styleProps), iconClassName, theme.palette("" + (styleProps.palette || 'primary'))(styleProps), theme.palette((styleProps.palette || 'primary') + "100")(styleProps), theme.theme(themeKey, "focusChecked")(styleProps), iconClassName, theme.palette("" + (styleProps.palette || 'primary'))(styleProps), checkedCss, iconClassName, disabledCheckedCss, checkedIconCss, theme.theme(themeKey, "checked")(styleProps), iconClassName, disabledCheckedIconCss, theme.theme(themeKey, "checkedDisabled")(styleProps), theme.theme(styleProps.themeKey, "css.root")(styleProps));
}

exports.getHiddenInputStyles = getHiddenInputStyles;
