'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('classnames');
require('emotion');
require('@emotion/core');
require('emotion-theming');
require('@emotion/styled');
var __chunk_1 = require('../chunk-4f52fe58.js');
require('tinycolor2');
require('./isFunction.js');
require('./get.js');
require('./theme.js');
var colors = require('./colors.js');

var generateTextVariants = function generateTextVariants(textColor) {
  return {
    text100: colors.lighten(0.2, textColor)(),
    text200: colors.lighten(0.15, textColor)(),
    text300: colors.lighten(0.1, textColor)(),
    text400: colors.lighten(0.05, textColor)(),
    text: textColor,
    textTint: colors.tint(0.8, textColor)(),
    textInverted: colors.readableColor(textColor)(),
    textTintInverted: colors.shade(0.3, textColor)()
  };
};
var generateColorVariants = function generateColorVariants(_ref) {
  var _objectSpread2;

  var color = _ref.color,
      paletteKey = _ref.paletteKey,
      paletteOverrides = _ref.paletteOverrides;
  return __chunk_1._objectSpread2((_objectSpread2 = {}, _objectSpread2[paletteKey + "100"] = colors.tint(0.7, color)(), _objectSpread2[paletteKey + "200"] = colors.tint(0.5, color)(), _objectSpread2[paletteKey + "300"] = colors.tint(0.3, color)(), _objectSpread2[paletteKey + "400"] = colors.tint(0.1, color)(), _objectSpread2[paletteKey] = color, _objectSpread2[paletteKey + "500"] = color, _objectSpread2[paletteKey + "600"] = colors.shade(0.1, color)(), _objectSpread2[paletteKey + "700"] = colors.shade(0.3, color)(), _objectSpread2[paletteKey + "800"] = colors.shade(0.5, color)(), _objectSpread2[paletteKey + "900"] = colors.shade(0.7, color)(), _objectSpread2[paletteKey + "Tint"] = colors.tint(0.9, color)(), _objectSpread2[paletteKey + "Inverted"] = colors.readableColor(color)(), _objectSpread2[paletteKey + "TintInverted"] = colors.shade(0.5, color)(), _objectSpread2), paletteOverrides ? paletteOverrides({
    color: color
  }) : {});
};

exports.generateColorVariants = generateColorVariants;
exports.generateTextVariants = generateTextVariants;
